// This is included in SPRAddSpriteYaroze2()

{
  int diff;
  int srcX, srcY, w, h;
  int clipPrint = 0;
  
  // If the image is partially off screen and we're not rotating or scaling then we can
  // just fiddle with the source image parameters so the sprite engine doesn't need to
  // do as much clipping.
  if ((xscale == (1<<16)) && (yscale == (1<<16)) && (angle == 0)) {
    srcX = sprite->src_x >> 16;
    srcY = sprite->src_y >> 16;
    w    = sprite->w;
    h    = sprite->h;

    // Clip off left side
    diff = ((w>>1) - x) & ~0x1L;
    if (diff > 0) {
      if (clipPrint) {
	printf("Clipping lft side (diff=%3d): Before XWSrc=%3d,%3d,%3d", diff, x, w, srcX);
      }
      w -= diff;
      srcX += diff;
      x += diff >> 1;
      if (clipPrint) {
	printf(" After XWSrc=%3d,%3d,%3d\n", x, w, srcX);
      }
    }

    // Clip off right side
    diff = (x + (w>>1) - screenW) & ~0x1L;
    if (diff > 0) {
      if (clipPrint) {
	printf("Clipping rit side (diff=%3d): Before XWSrc=%3d,%3d,%3d", diff, x, w, srcX);
      }
      w -= diff;
      x -= diff >> 1;
      if (clipPrint) {
	printf(" After XWSrc=%3d,%3d,%3d\n", x, w, srcX);
      }
    }

    // Clip off top side
    diff = ((h>>1) - y) & ~0x1L;
    if (diff > 0) {
      if (clipPrint) {
	printf("Clipping top side (diff=%3d): Before YHSrc=%3d,%3d,%3d", diff, y, h, srcY);
      }
      h -= diff;
      srcY += diff;
      y += diff >> 1;
      if (clipPrint) {
	printf(" After YHSrc=%3d,%3d,%3d\n", y, h, srcY);
      }
    }

    // Clip off bottom side
    diff = (y + (h>>1) - screenH) & ~0x1L;
    if (diff > 0) {
      if (clipPrint) {
	printf("Clipping bot side (diff=%3d): Before YHSrc=%3d,%3d,%3d", diff, y, h, srcY);
      }
      h -= diff;
      y -= diff >> 1;
      if (clipPrint) {
	printf(" After YHSrc=%3d,%3d,%3d\n", y, h, srcY);
      }
    }

    SPRSetSpriteSource(sprite, srcX, srcY, w, h);

    if ((w <= 0) || (h <= 0)) {
      if (clipPrint) {
	printf("Deleting sprite\n");
      }
      return 1;
    }
  }
}
