	METHOD		= 1
	ENHANCE		= 1
	
	.overlay clrCF
	.origin pixgen

	tmp_r16		= r16
	tmp_r17		= r17
	firstChunk_r17	= r17
	lastChunk_r18	= r18
	drawBuffPtr_r19	= r19

	pixel_v0	= v0
.if (METHOD == 1)
	destPixel_v0	= v0
	destPixelY_r0	= r0
	destPixelCr_r1	= r1
	destPixelCb_r2	= r2
.endif
	const1dot24_r3	= r3

.if (METHOD == 1)
	fadeAmt_v1	= v1
	fadeAmtR_r4	= r4
	fadeAmtG_r5	= r5
	fadeAmtB_r6	= r6
.endif
	const4_r7	= r7

.if (METHOD == 1)
	destPixelRGB_v2	= v2
	destPixelR_r8	= r8
	destPixelG_r9	= r9
	destPixelB_r10	= r10
	const1dot24_r11	= r11
.endif
	destPixel_v2	= v2
	destPixelY_r8	= r8
	destPixelCr_r9	= r9
	destPixelCb_r10	= r10

.if (0)
	convToR_v5	= v5
	convToG_v6	= v6
	convToB_v7	= v7
	convToY_v5	= v5
	convToCr_v6	= v6
	convToCb_v7	= v7
.endif
	convYToY_v5	= v5
	convCrToCr_v6	= v6
	convCbToCb_v7	= v7

clearTypeCopyFade:
.if (0)
	mv_s	#1,r0
`hang:
	cmp	#1,r0
	jmp	eq,`hang,nop
.endif

	mv_s	#4,const4_r7
	
	ld_s	dma__cmd+0,tmp_r12
	ld_s	clrParam1,tmp_r16		; source buffer address
	ld_s	clrParam2,tmp_r17		; read DMA flags for source buffer
	
	bset	#30,tmp_r12			; set the BATCH bit in this DMA packet
	st_s	tmp_r12,dma__cmd+0
	
	st_s	tmp_r16,dma__cmd2+4		; for writing source pixels
	st_s	tmp_r16,dma__cmd3+4		; for reading source pixels

	copy	tmp_r17,tmp_r12
	bset	#30,tmp_r17			; set the BATCH bit in this DMA packet
	st_s	tmp_r17,dma__cmd2+0		; store flags for writing back source buffer
	bset	#13,tmp_r12			; set READ bit
	st_s	tmp_r12,dma__cmd3+0		; store flags for reading source buffer
	
.if (METHOD == 2)
	ld_s	clrParam3,tmp_r12
	nop
	bset	#SPR_HINT_MATPREP_BOTH,tmp_r12
	st_s	tmp_r12,spr_bright
	jsr	matPrep,nop
	
	ld_v	convYToFG,convYToY_v5
	ld_v	convCrToFG,convCrToCr_v6
	ld_v	convCbToFG,convCbToCb_v7
	nop
.endif
		
	
	mv_s	#2,firstChunk_r17
	mv_s	#0,lastChunk_r18

`nextBlockVert:
	cmp	#8,hRemaining_r4
{
	jmp	ge,`gotHeight,nop
	mv_s	#8,hCur_r11			; Assume 8 pixels
}
	copy	hRemaining_r4,hCur_r11		; Nope, was not 8, clamp
`gotHeight:

	ld_s	xclip,xCur_r8
	st_s	#(4<<20),linpixctl		; hide NOP
	lsr	#16,xCur_r8,wRemaining_r6
	bits	#15,>>#0,xCur_r8
	sub	xCur_r8,wRemaining_r6		; Get width in pixels
	add	#1,wRemaining_r6

`nextBlockHoriz:
	cmp	#8,wRemaining_r6		; Check if rest of width is less than 8
{
	jmp	ge,`gotWidth,nop
	mv_s	#8,wCur_r10
}
	copy	wRemaining_r6,wCur_r10
`gotWidth:

`processLastChunks:
.if (1)
	mv_s	#dma__cmd3+16,r20

	;; Transfer info for buffer we just read to the two write DMAs
	ld_s	(r20),tmp_r12			; read the previous buffer address
	ld_s	tmpdata+16,tmp_r16
	st_s	tmp_r12,tmpdata+16
	ld_s	srcBuffLoad,tmp_r12		; address where to load the pixels
	st_s	tmp_r16,dma__cmd+16		; store the pixels we just drew to dest buffer
	st_s	tmp_r16,dma__cmd2+16		; store the pixels we just drew back to src buffer
	st_s	tmp_r12,(r20)			; read next set of src pixels
	
	sub	#8,r20
	ld_s	(r20),tmp_r12			; X & W of chunk we just read
	ld_s	tmpdata+8,tmp_r16		; (will be invalid first two times through)
	st_s	tmp_r12,tmpdata+8
	st_s	tmp_r16,dma__cmd+8
	st_s	tmp_r16,dma__cmd2+8
	lsl	#16,wCur_r10,tmp_r12		; construct the X pos and W for next chunk
	add	xCur_r8,tmp_r12
	st_s	tmp_r12,(r20)

	add	#4,r20
	ld_s	(r20),tmp_r12			; Y & H of chunk we just read
	ld_s	tmpdata+12,tmp_r16		; (will be invalid first two times through)
	st_s	tmp_r12,tmpdata+12
	st_s	tmp_r16,dma__cmd+12
	st_s	tmp_r16,dma__cmd2+12
	lsl	#16,hCur_r11,tmp_r12		; construct the Y pos and H for next chunk
	add	yCur_r9,tmp_r12
	st_s	tmp_r12,(r20)

	;; Get the DMA cmd to use.  For the first time two times through we just read.  The last 
	;; two times through we just write.  The other times through we do both.
	sub	#12,r20
	copy	r20,tmp_r12
	cmp	#1,firstChunk_r17		; only do read if this is the first chunk
	bra	ge,`gotDMACmd,nop
 	mv_s	#dma__cmd,tmp_r12 
.else	
	;; Transfer info for buffer we just read to the two write DMAs
	ld_s	dma__cmd3+16,tmp_r12		; read the previous buffer address
	ld_s	tmpdata+16,tmp_r16
	st_s	tmp_r12,tmpdata+16
	st_s	tmp_r16,dma__cmd+16		; store the pixels we just drew to dest buffer
	st_s	tmp_r16,dma__cmd2+16		; store the pixels we just drew back to src buffer
	
	ld_s	dma__cmd3+8,tmp_r12		; X & W of chunk we just read
	ld_s	tmpdata+8,tmp_r16		; (will be invalid first two times through)
	st_s	tmp_r12,tmpdata+8
	st_s	tmp_r16,dma__cmd+8
	st_s	tmp_r16,dma__cmd2+8

	ld_s	dma__cmd3+12,tmp_r12		; Y & H of chunk we just read
	ld_s	tmpdata+12,tmp_r16		; (will be invalid first two times through)
	st_s	tmp_r12,tmpdata+12
	st_s	tmp_r16,dma__cmd+12
	ld_s	srcBuffLoad,tmp_r12		; address where to load the pixels (hiding NOP)
	st_s	tmp_r16,dma__cmd2+12

	;; Now update the new read DMA with the latest chunk info
	st_s	tmp_r12,dma__cmd3+16		; read next set of src pixels
	
	lsl	#16,wCur_r10,tmp_r12		; construct the X pos and W for next chunk
	add	xCur_r8,tmp_r12
	st_s	tmp_r12,dma__cmd3+8

	lsl	#16,hCur_r11,tmp_r12		; construct the Y pos and H for next chunk
	add	yCur_r9,tmp_r12
	st_s	tmp_r12,dma__cmd3+12

	;; Get the DMA cmd to use.  For the first time two times through we just read.  The last 
	;; two times through we just write.  The other times through we do both.
	mv_s	#dma__cmd3,tmp_r12
	cmp	#1,firstChunk_r17		; only do read if this is the first chunk
	bra	ge,`gotDMACmd,nop
 	mv_s	#dma__cmd,tmp_r12 
;	sub	#(dma__cmd3-dma__cmd),tmp_r12
.endif

`gotDMACmd:
	jsr	mdma_finished,nop		; make sure the current chunk is ready
	st_s	tmp_r12,mdmacptr		; start the DMA(s) while we process this chunk

	cmp	#2,firstChunk_r17		; only process if not the first pass through
	bra	eq,`skipProcess,nop

	cmp	#2,lastChunk_r18		; only process if not the last pass through
	bra	eq,`skipProcess,nop
	
	;; Iterate through all the pixels to fade them
;	jmp	`skipProcess,nop
	
.if (METHOD == 3)
	mv_s	#$20<<22,r20
	mv_s	#$80<<22,r21
	mv_s	#$80<<22,r22
	mv_s	#1<<20,r23
	ld_s	srcBuffDraw,drawBuffPtr_r19	; get buffer pointer
	copy	wCur_r10,tmp_r12
	mul	hCur_r11,tmp_r12,>>#0,tmp_r12	; get pixel count
	nop
	st_s	tmp_r12,rc0
`processNextPixel:
	ld_p	(drawBuffPtr_r19),pixel_v0
	dec	rc0
	sub_p	v5,pixel_v0,v6
	mul_p	r23,v6,>>#24,v7
	nop
	bclr	#22,r29
	bclr	#22,r30
	bset	#21,r29
	bset	#21,r30
	sub_p	v7,pixel_v0,v7
	bra	c0ne,`processNextPixel
	nop
{	st_p	v7,(drawBuffPtr_r19)
	add	#4,drawBuffPtr_r19
}
.endif
	
.if (METHOD == 2)
	ld_s	srcBuffDraw,drawBuffPtr_r19	; get buffer pointer
	copy	wCur_r10,tmp_r12
	mul	hCur_r11,tmp_r12,>>#0,tmp_r12	; get pixel count
	nop
	st_s	tmp_r12,rc0
	push	v1
	push	v2
	mv_s	#(1<<24),const1dot24_r3
`processNextPixel:
	ld_p	(drawBuffPtr_r19),pixel_v0
	dec	rc0
	dotp	convYToY_v5,pixel_v0,>>#24,destPixelY_r8
	dotp	convCrToCr_v6,pixel_v0,>>#24,destPixelCr_r9
{
	bra	c0ne,`processNextPixel
	dotp	convCbToCb_v7,pixel_v0,>>#24,destPixelCb_r10
}
	nop
{	st_p	destPixel_v2,(drawBuffPtr_r19)
	add	#4,drawBuffPtr_r19
}
	pop	v2
	pop	v1
.endif

.if (METHOD == 1)
	ld_s	srcBuffDraw,drawBuffPtr_r19	; get buffer pointer
	copy	wCur_r10,tmp_r12
	mul	hCur_r11,tmp_r12,>>#0,tmp_r12	; get pixel count
	push	v1
	st_s	tmp_r12,rc0
	push	v2
	ld_s	const1dot24,const1dot24_r3
	ld_p	clrParam3,fadeAmt_v1
	copy	const1dot24_r3,const1dot24_r11

.if (ENHANCE == 1)
`processNextPixel1:
	ld_s	(drawBuffPtr_r19),tmp_r12
`processNextPixel2:
	bra	c0eq,`done,nop
`processNextPixel:
	addm	const4_r7,drawBuffPtr_r19	; advance to next pixenl
{
	dec	rc0
	cmp	#$10808000,tmp_r12
}
{
	bra	eq,`processNextPixel2,nop
	ld_s	(drawBuffPtr_r19),tmp_r12
}
	sub	#4,drawBuffPtr_r19		; compensate if branch wasn't taken
.else
`processNextPixel:
.endif
	ld_p	(drawBuffPtr_r19),pixel_v0
	ld_v	convToR,convToR_v5
	ld_v	convToG,convToG_v6
	ld_v	convToB,convToB_v7
	dotp	convToR_v5,pixel_v0,>>#24,destPixelR_r8
	dotp	convToG_v6,pixel_v0,>>#24,destPixelG_r9
	dotp	convToB_v7,pixel_v0,>>#24,destPixelB_r10

	sub	fadeAmtR_r4,destPixelR_r8
	bra	ge,`skipSatR,nop
	eor	destPixelR_r8,destPixelR_r8
`skipSatR:
	sub	fadeAmtG_r5,destPixelG_r9
	bra	ge,`skipSatG,nop
	eor	destPixelG_r9,destPixelG_r9
`skipSatG:
	sub	fadeAmtB_r6,destPixelB_r10
	bra	ge,`skipSatB,nop
	eor	destPixelB_r10,destPixelB_r10
`skipSatB:
	
	ld_v	convToY,convToY_v5
	ld_v	convToCr,convToCr_v6
	ld_v	convToCb,convToCb_v7
	dotp	convToY_v5,destPixelRGB_v2,>>#24,destPixelY_r0
	dotp	convToCr_v6,destPixelRGB_v2,>>#24,destPixelCr_r1
	dotp	convToCb_v7,destPixelRGB_v2,>>#24,destPixelCb_r2

.if (ENHANCE == 0)
	dec	rc0
.endif

	bra	c0ne,`processNextPixel1
	st_p	destPixel_v0,(drawBuffPtr_r19)
	add	#4,drawBuffPtr_r19
`done:
	pop	v2
	pop	v1
.endif
`skipProcess:

	ld_s	srcBuffDraw,tmp_r12		; swap the buffers
	ld_s	srcBuffLoad,tmp_r16
	st_s	tmp_r12,srcBuffLoad
	st_s	tmp_r16,srcBuffDraw

	lsr	#1,firstChunk_r17

	jsr	mdma_wait,nop

	add	wCur_r10,xCur_r8
	sub	wCur_r10,wRemaining_r6
	bra	gt,`nextBlockHoriz,nop
	
	add	hCur_r11,yCur_r9
	sub	hCur_r11,hRemaining_r4
	bra	gt,`nextBlockVert,nop

	;; Process the last chunks
	ld_s	dma__cmd2+0,tmp_r12
	eor	wCur_r10,wCur_r10		; clear these out so the compares still fall through
	eor	hCur_r11,hCur_r11		; hiding a NOP
	and	#~(1<<30),tmp_r12		; clear the BATCH bit so the read doesn't happen
	st_s	tmp_r12,dma__cmd2+0		; store flags for writing back source buffer

	add	#1,lastChunk_r18
	cmp	#2,lastChunk_r18
	bra	le,`processLastChunks,nop
alldone:
	jmp	nextSlice
	nop
	nop

end_clearTypeCopyFade:
	