	.overlay clrCT
	.origin pixgen

.if (0)
	tmp_r16		= r16
.endif

	srcXOffset_r20	= r20
	srcYOffset_r21	= r21
	srcXCur_r22	= r22
	srcYCur_r23	= r23

	srcW_r24	= r24
	srcH_r25	= r25
	srcWRemaining_r26	= r26
	srcHRemaining_r27	= r27

clearTypeCopyTile:
.if (0)
	mv_s	#1,r0
`hang:
	cmp	#1,r0
	jmp	eq,`hang,nop
.endif
	
	ld_s	clrParam1,tmp_r12		; source buffer address
	nop
	st_s	tmp_r12,dma__cmd2+4		; for reading source pixels

	ld_s	clrParam2,tmp_r12		; DMA flags for source buffer
	nop
	or	#(1<<13),tmp_r12		; set READ bit
	st_s	tmp_r12,dma__cmd2+0		; store flags for reading source buffer

	copy	tmp_r12,srcW_r24		; extract source width from the flags
	bits	#7,>>#16,srcW_r24		; source width is in [23:16]
	lsl	#3,srcW_r24			; value in flags is width/8

	ld_s	srcBuffLoad,tmp_r12		; address where to keep the pixels locally
	nop
	st_s	tmp_r12,dma__cmd+16		; for writes
	st_s	tmp_r12,dma__cmd2+16		; for reads
	
	ld_s	clrParam3,srcXOffset_r20	; get the X/Y offsets and source height
	nop
	copy	srcXOffset_r20,srcYOffset_r21
	copy	srcXOffset_r20,srcH_r25
	bits	#9,>>#20,srcH_r25		; source H is in [29:20]
	lsl	#12,srcYOffset_r21
	asr	#22,srcYOffset_r21		; Y offset is in [19:10]
	lsl	#22,srcXOffset_r20
	asr	#22,srcXOffset_r20		; X offset is in [ 9: 0]

	;; Adjust the Y offset to the start of this slice
	add	yCur_r9,srcYOffset_r21
`checkYOffset:
	cmp	#0,srcYOffset_r21
	bra	ge,`gotYOffset1,nop
{	bra	`checkYOffset,nop
	add	srcH_r25,srcYOffset_r21
}
`gotYOffset1:
	cmp	srcH_r25,srcYOffset_r21
	bra	le,`gotYOffset2,nop
{	bra	`gotYOffset1,nop
	sub	srcH_r25,srcYOffset_r21
}
`gotYOffset2:
	copy	srcH_r25,srcHRemaining_r27
	sub	srcYOffset_r21,srcHRemaining_r27 ; adjust the height remaining based on the offset
	copy	srcYOffset_r21,srcYCur_r23
	
	;; Adjust the X offset to the clip rectangle
	ld_s	xclip,tmp_r12
	nop
	bits	#15,>>#0,tmp_r12		; get X-min
	add	tmp_r12,srcXOffset_r20
`checkXOffset:
	cmp	#0,srcXOffset_r20
	bra	ge,`gotXOffset1,nop
{	bra	`checkXOffset,nop
	add	srcW_r24,srcXOffset_r20
}
`gotXOffset1:
	cmp	srcW_r24,srcXOffset_r20
	bra	le,`gotXOffset2,nop
{	bra	`gotXOffset1,nop
	sub	srcW_r24,srcXOffset_r20
}
`gotXOffset2:
		
`nextBlockVert:
	cmp	#8,hRemaining_r4
{	bra	ge,`gotHeight,nop
	mv_s	#8,hCur_r11			; assume 8 pixels
}
	copy	hRemaining_r4,hCur_r11		; nope, less than 8 left in this slice - clamp
`gotHeight:
	cmp	hCur_r11,srcHRemaining_r27	; see if we must clamp to the source image
	bra	ge,`gotHeight2,nop
	copy	srcHRemaining_r27,hCur_r11
`gotHeight2:	

	ld_s	xclip,xCur_r8
	nop
	lsr	#16,xCur_r8,wRemaining_r6
	bits	#15,>>#0,xCur_r8
	sub	xCur_r8,wRemaining_r6		; get width in pixels
	add	#1,wRemaining_r6
	
	copy	srcW_r24,srcWRemaining_r26	; reset the remaining width
	sub	srcXOffset_r20,srcWRemaining_r26; adjust the width remaining based on the offset
	copy	srcXOffset_r20,srcXCur_r22	; reset the source coords
	
`nextBlockHoriz:
	cmp	#8,wRemaining_r6		; check if rest of width is less than 8
{	bra	ge,`gotWidth,nop
	mv_s	#8,wCur_r10
}
	copy	wRemaining_r6,wCur_r10
`gotWidth:
	cmp	wCur_r10,srcWRemaining_r26	; see if we must clamp to the source image
	bra	ge,`gotWidth2,nop
	copy	srcWRemaining_r26,wCur_r10
`gotWidth2:	

`processLastChunks:
	jsr	mdma_wait,nop

	;; Do the read DMA
	copy	srcXCur_r22,tmp_r12		; construct the X pos and W for next chunk
	add	wCur_r10,>>#-16,tmp_r12
	st_s	tmp_r12,dma__cmd2+8

	copy	srcYCur_r23,tmp_r12		; construct the Y pos and H for next chunk
	add	hCur_r11,>>#-16,tmp_r12
	st_s	tmp_r12,dma__cmd2+12

	st_s	#dma__cmd2,mdmacptr		; start the DMA to read the chunk
	jsr	mdma_wait,nop
	
	;; Advance the source image attributes, wrapping if necessary
	add	wCur_r10,srcXCur_r22		; increment the source X coord
	sub	wCur_r10,srcWRemaining_r26	; decrement the source W remaining
	bra	gt,`srcXNoOverflow,nop		; see if we need to start over on the source image
	mv_s	#0,srcXCur_r22
;	copy	srcXOffset_r20,srcXCur_r22	; restore source x offset
	copy	srcW_r24,srcWRemaining_r26	; restore source width
`srcXNoOverflow:

	;; Do the write DMA
	copy	xCur_r8,tmp_r12			; construct the X pos and W for next chunk
	add	wCur_r10,>>#-16,tmp_r12
	st_s	tmp_r12,dma__cmd+8
	
	copy	yCur_r9,tmp_r12			; construct the Y pos and H for next chunk
	add	hCur_r11,>>#-16,tmp_r12
	st_s	tmp_r12,dma__cmd+12
	
	jsr	mdma_finished,nop		; make sure the current chunk is ready
	st_s	#dma__cmd,mdmacptr		; start the DMA to write the chunk
	
	;; Advance the destination attributes, wrapping if necessary
	add	wCur_r10,xCur_r8		; increment the destination X coord
	sub	wCur_r10,wRemaining_r6		; decrement the destination W remaining
	bra	gt,`nextBlockHoriz,nop		; jump back if not done with this row

	;;
	;; Get here when we're done with this row of chunks
	;; 
	
	;; Advance the source image attributes, wrapping if necessary
	add	hCur_r11,srcYCur_r23		; increment the source Y coord
	sub	hCur_r11,srcHRemaining_r27	; decrement the source H remaining
	bra	gt,`srcYNoOverflow,nop		; see if we need to start over on the source image
	mv_s	#0,srcYCur_r23
;	copy	srcYOffset_r21,srcYCur_r23	; restore source y offset
	copy	srcH_r25,srcHRemaining_r27	; restore source height
`srcYNoOverflow:
	
	;; Advance the destination attributes, wrapping if necessary
	add	hCur_r11,yCur_r9		; increment the destination Y coord
	sub	hCur_r11,hRemaining_r4		; decrement the destination H remaining
	bra	gt,`nextBlockVert,nop		; jump back if not done with this slice

	jmp	nextSlice,nop

end_clearTypeCopyTile:
	