	.overlay clrStars
	.origin pixgen
	
	yClipMin_r22	= r22
	yClipMax_r23	= r23

clearTypeStar:
	;; Make a copy of the Y clip extents for later
	copy	yCur_r9,yClipMin_r22
	add	hRemaining_r4,yClipMin_r22,yClipMax_r23
	sub	#1,yClipMax_r23
	
	;; Set up the DMA command as much as we can
	ld_s	dma__cmd+0,tmp_r12		; have to set the DIRECT bit
	nop
	or	#(1<<27),tmp_r12
	st_s	tmp_r12,dma__cmd+0

	ld_s	bgColor,tmp_r12
	nop	
	st_s	tmp_r12,dma__cmd+16		; store the color in the direct data

`nextBlockVert:
	cmp	#8,hRemaining_r4
	jmp	ge,`gotHeight
	mv_s	#8,hCur_r11			; assume 8 pixels
	nop
	copy	hRemaining_r4,hCur_r11		; nope, was not 8, clamp
`gotHeight:

	ld_s	xclip,tmp_r12
	nop
	lsr	#16,tmp_r12,wRemaining_r6
	and	#$FFFF,tmp_r12
	sub	tmp_r12,wRemaining_r6		; get width in pixels
	add	#1,wRemaining_r6

	ld_s	xclip,xCur_r8
	nop
	and	#$FFFF,xCur_r8			; initialize current X coord

`nextBlockHoriz:
	cmp	#8,wRemaining_r6		; check if rest of width is less than 8
	jmp	ge,`gotWidth
	mv_s	#8,wCur_r10
	nop
	copy	wRemaining_r6,wCur_r10
`gotWidth:

	lsl	#16,wCur_r10,tmp_r12		; construct the X pos and W
	add	xCur_r8,tmp_r12
	st_s	tmp_r12,dma__cmd+8

	lsl	#16,hCur_r11,tmp_r12		; construct the Y pos and H
	add	yCur_r9,tmp_r12
	st_s	tmp_r12,dma__cmd+12

	st_s	#dma__cmd,mdmacptr		; start the DMA
	
{	jsr	mdma_wait,nop
	DMAWAITCNT_ITEM 8
}

	add	wCur_r10,xCur_r8
	sub	wCur_r10,wRemaining_r6
	jmp	gt,`nextBlockHoriz,nop
	
	add	hCur_r11,yCur_r9
	sub	hCur_r11,hRemaining_r4
	jmp	gt,`nextBlockVert,nop

;;; 
;;; Now ready to add stars
;;;
	xClipMin_r20	= r20
	xClipMax_r21	= r21

	starPtr_r24	= r24
	starX_r25	= r25
	starY_r26	= r26
	starColor_r27	= r27

	loadPtr_r28	= r28

	STARS_PER_BATCH	= 16

.if 0
	mv_s	#1,r0
`hang:
	btst	#0,r0
	bra	ne,`hang,nop
.endif
	
	;; Extract the clip extents
	ld_s	xclip,xClipMin_r20
	nop
	lsr	#16,xClipMin_r20,xClipMax_r21
	and	#$FFFF,xClipMin_r20

	;; Get the initial batch of star locations
	ld_s	clrParam2,loadPtr_r28
	nop
	st_s	#((1<<13)|((STARS_PER_BATCH*2)<<16)),dma__cmd2+0	; dma flags (linear read of 32 scalars)
	cmp	#0,loadPtr_r28
	bra	eq,`doneStars,nop		; quit if read pointer is null
	st_s	loadPtr_r28,dma__cmd2+4		; store read pointer in dma command
	ld_s	srcBuffLoad,tmp_r12		; address where to keep the data locally
	nop
	st_s	tmp_r12,dma__cmd2+8
	st_s	#dma__cmd2,odmacptr		; start the DMA

	ld_s	clrParam3,tmp_r12		; get total number of stars
	nop
	st_s	tmp_r12,rc1
	
	;; Preload the next batch of pixels
`nextBatch:	
	jsr	odma_finished,nop		; wait until the previous batch has been read
	add	#(STARS_PER_BATCH*2)<<2,loadPtr_r28
	st_s	loadPtr_r28,dma__cmd2+4		; update read pointer in dma command
	
	ld_s	srcBuffDraw,tmp_r12		; swap the buffers
	ld_s	srcBuffLoad,tmp_r16
	st_s	tmp_r12,srcBuffLoad
	st_s	tmp_r16,srcBuffDraw
		
	ld_s	srcBuffLoad,tmp_r12		; address where to keep the data locally
	nop
	st_s	tmp_r12,dma__cmd2+8
	st_s	#dma__cmd2,odmacptr		; start the DMA

	;; Process the previous batch while the next one is being read

	st_s	#STARS_PER_BATCH,rc0
	ld_s	srcBuffDraw,starPtr_r24
	nop

`nextStar:
	ld_s	(starPtr_r24),starX_r25		; get the star coordinates
	add	#4,starPtr_r24
	copy	starX_r25,starY_r26
	asr	#16,starY_r26			; extract the (signed) y-coordinate
	asl	#16,starX_r25			; extract the (signed) x-coordinate
	asr	#16,starX_r25
	ld_s	(starPtr_r24),starColor_r27	; get the star color
	add	#4,starPtr_r24

	;; Make sure the star is not clipped
	cmp	xClipMin_r20,starX_r25
	bra	lt,`starClipped
	cmp	xClipMax_r21,starX_r25
	bra	gt,`starClipped
	cmp	yClipMin_r22,starY_r26
	bra	lt,`starClipped
	cmp	yClipMax_r23,starY_r26
	bra	gt,`starClipped

	;; Put the star coordinates and color in the DMA command
	jsr	mdma_wait,nop			; wait until previous dma is accepted
	or	#(1<<16),starX_r25,tmp_r12
	st_s	tmp_r12,dma__cmd+8		; X pos and W
	or	#(1<<16),starY_r26,tmp_r12
	st_s	tmp_r12,dma__cmd+12		; Y pos and H
	st_s	starColor_r27,dma__cmd+16	; star color
	st_s	#dma__cmd,mdmacptr		; start the DMA
`starClipped:

	dec	rc1
	bra	c1eq,`doneStars
	dec	rc0
	bra	c0ne,`nextStar

	bra	`nextBatch,nop

`doneStars:
	jsr	odma_finished,nop
	jsr	mdma_finished,nop
	jmp	nextSlice
	nop
	nop
