;;;
;;; y'  = (y  - 16) / 219
;;; cr' = (cr - 128) / 224
;;; cb' = (cb - 128) / 224
;;;
;;; r' = y' + 1.40200*cr'
;;; g' = y' - 0.34414*cb' - 0.71414*cr'
;;; b' = y' + 1.77200*cb'
;;;
;;; r = r' * 255
;;; g = g' * 255
;;; b = b' * 255
;;;
	Y_OFF	= -16
	CR_OFF	= -128
	CB_OFF	= -128
	
	Y_DIV	= 219
	CR_DIV	= 224
	CB_DIV	= 224

	R_Y	= 1.0
	R_CR	= 1.40200
	R_CB	= 0

	G_Y	= 1.0
	G_CR	= -0.71414
	G_CB	= -0.34414

	B_Y	= 1.0
	B_CR	= 0
	B_CB	= 1.77200
		
	;; The "|0" is necessary due to a bug in the pre-assembler.  Doing fix()+(1<<15)
	;; doesn't work for some reason.
	.align.v

	R_FROM_Y	= ((fix(255*(R_Y  / Y_DIV ),24)|0)+(1<<15))&$FFFF0000	; 1.164
	R_FROM_CR	= ((fix(255*(R_CR / CR_DIV),24)|0)+(1<<15))&$FFFF0000	; 1.596
	R_FROM_CB	= ((fix(255*(R_CB / CB_DIV),24)|0)+(1<<15))&$FFFF0000	; 0
	R_FROM_CONST	= ((fix(255*(Y_OFF*R_Y/Y_DIV + CR_OFF*R_CR/CR_DIV + CB_OFF*R_CB/CB_DIV),22)|0)+(1<<15))&$FFFF0000	; -222.9
convToR:
	.dc.s	R_FROM_Y
	.dc.s	R_FROM_CR
	.dc.s	R_FROM_CB
	.dc.s	R_FROM_CONST

	G_FROM_Y	= ((fix(255*(G_Y  / Y_DIV ),24)|0)+(1<<15))&$FFFF0000	; 1.164
	G_FROM_CR	= ((fix(255*(G_CR / CR_DIV),24)|0)+(1<<15))&$FFFF0000	; -0.813
	G_FROM_CB	= ((fix(255*(G_CB / CB_DIV),24)|0)+(1<<15))&$FFFF0000	; -0.392
	G_FROM_CONST	= ((fix(255*(Y_OFF*G_Y/Y_DIV + CR_OFF*G_CR/CR_DIV + CB_OFF*G_CB/CB_DIV),22)|0)+(1<<15))&$FFFF0000	; 135.6
convToG:
	.dc.s	G_FROM_Y
	.dc.s	G_FROM_CR
	.dc.s	G_FROM_CB
	.dc.s	G_FROM_CONST

	B_FROM_Y	= ((fix(255*(B_Y  / Y_DIV ),24)|0)+(1<<15))&$FFFF0000	; 1.164
	B_FROM_CR	= ((fix(255*(B_CR / CR_DIV),24)|0)+(1<<15))&$FFFF0000	; 0
	B_FROM_CB	= ((fix(255*(B_CB / CB_DIV),24)|0)+(1<<15))&$FFFF0000	; 2.017
	B_FROM_CONST	= ((fix(255*(Y_OFF*B_Y/Y_DIV + CR_OFF*B_CR/CR_DIV + CB_OFF*B_CB/CB_DIV),22)|0)+(1<<15))&$FFFF0000	; -276.8
convToB:
	.dc.s	B_FROM_Y
	.dc.s	B_FROM_CR
	.dc.s	B_FROM_CB
	.dc.s	B_FROM_CONST
	
;;; 
;;; r' = r / 255
;;; g' = g / 255
;;; b' = b / 255
;;; 
;;; y'  =  (0.299 * r') + (0.587 * g') + (0.114 * b')
;;; cr' =  (0.500 * r') - (0.419 * g') - (0.081 * b')
;;; cb' = -(0.169 * r') - (0.331 * g') + (0.500 * b')
;;; 
;;; y  = 219.0 * y'  + 16.0
;;; cr = 224.0 * cr' + 128.0
;;; cb = 224.0 * cb' + 128.0
;;; 
	Y_R	= 0.299
	Y_G	= 0.587
	Y_B	= 0.114

	CR_R	= 0.500
	CR_G	= -0.419
	CR_B	= -0.081

	CB_R	= -0.169
	CB_G	= -0.331
	CB_B	= 0.500

	Y_MULT	= Y_DIV
	CR_MULT	= CR_DIV
	CB_MULT	= CB_DIV

	Y_FROM_R	= ((fix(Y_MULT * Y_R/255,24)|0)+(1<<15))&$FFFF0000
	Y_FROM_G	= ((fix(Y_MULT * Y_G/255,24)|0)+(1<<15))&$FFFF0000
	Y_FROM_B	= ((fix(Y_MULT * Y_B/255,24)|0)+(1<<15))&$FFFF0000
	Y_FROM_CONST	= ((fix(16,22)|0)+(1<<15))&$FFFF0000
convToY:
	.dc.s	Y_FROM_R
	.dc.s	Y_FROM_G
	.dc.s	Y_FROM_B
	.dc.s	Y_FROM_CONST

	CR_FROM_R	= ((fix(CR_MULT * CR_R/255,24)|0)+(1<<15))&$FFFF0000
	CR_FROM_G	= ((fix(CR_MULT * CR_G/255,24)|0)+(1<<15))&$FFFF0000
	CR_FROM_B	= ((fix(CR_MULT * CR_B/255,24)|0)+(1<<15))&$FFFF0000
	CR_FROM_CONST	= ((fix(128,22)|0)+(1<<15))&$FFFF0000
convToCr:
	.dc.s	CR_FROM_R
	.dc.s	CR_FROM_G
	.dc.s	CR_FROM_B
	.dc.s	CR_FROM_CONST
	
	CB_FROM_R	= ((fix(CB_MULT * CB_R/255,24)|0)+(1<<15))&$FFFF0000
	CB_FROM_G	= ((fix(CB_MULT * CB_G/255,24)|0)+(1<<15))&$FFFF0000
	CB_FROM_B	= ((fix(CB_MULT * CB_B/255,24)|0)+(1<<15))&$FFFF0000
	CB_FROM_CONST	= ((fix(128,22)|0)+(1<<15))&$FFFF0000
convToCb:
	.dc.s	CB_FROM_R
	.dc.s	CB_FROM_G
	.dc.s	CB_FROM_B
	.dc.s	CB_FROM_CONST

convYToFG:
	.ds.s	4
convCrToFG:
	.ds.s	4
convCbToFG:
	.ds.s	4

convYToBG:
	.ds.s	4
convCrToBG:
	.ds.s	4
convCbToBG:
	.ds.s	4

