// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
// TODO: Verify double buffering works with any old sprite app.
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

#ifndef LIBSPRITE_INLINE
#include <stdio.h>
#include <malloc.h>
#include <nuon/bios.h>
#include <nuon/dma.h>
#include <nuon/comm.h>
#include <nuon/intr.h>
#include <nuon/mutil.h>
#endif
#include "queue.h"
#include "sprite2.h"
#include "sprite2b.h"

#define MAX_SPRITES 512
#define MAX_MPES 3

#define MULTI_LIST

#define FUNC_TRACE 0

extern int spritec_start[], spritec_size[];
extern int sprited_start[], sprited_size[];
extern volatile int SpriteBase;
extern volatile int object;
extern volatile int mpeinfo;

extern int pixgen0_start[], pixgen0_size[];
extern int pixgen1_start[], pixgen1_size[];
extern int pixgen4_start[], pixgen4_size[];
extern int pixgen6_start[], pixgen6_size[];

extern int spTp_start   [], spTp_size   [];
extern int spTpBS_start [], spTpBS_size [];
extern int spTpB_start  [], spTpB_size  [];
extern int spTpBP_start [], spTpBP_size [];
extern int spTl_start   [], spTl_size   [];
extern int spTlPA_start [], spTlPA_size [];
extern int spTlRA_start [], spTlRA_size [];
extern int spTlRPA_start[], spTlRPA_size[];
extern int spTlA_start  [], spTlA_size  [];
extern int spTlE_start  [], spTlE_size  [];
extern int spTlER_start [], spTlER_size [];
extern int spTlEA_start [], spTlEA_size [];
extern int spTlZ_start  [], spTlZ_size  [];
extern int spTlZR_start [], spTlZR_size [];
extern int spTlEZ_start [], spTlEZ_size [];
extern int spTlEZA_start[], spTlEZA_size[];
extern int spTlME_start [], spTlME_size [];
extern int spTlMEA_start[], spTlMEA_size[];

extern int pixyar2X_start[], pixyar2X_size[];

// Points & lines
extern int spPoint_start[], spPoint_size[];
extern int spLine_start[],  spLine_size[];
extern int spGLine_start[], spGLine_size[];

// Simple sprites
extern int spSTp_start[],   spSTp_size[];

extern int clrColor_start[], clrColor_size[];
extern int clrCF_start[],    clrCF_size[];
extern int clrCT_start[],    clrCT_size[];
extern int clrStars_start[], clrStars_size[];


enum {
  kRendererFlagTransparent = (1<<0),
  kRendererFlagBright      = (1<<1),
  kRendererFlagTranslucent = (1<<2),
  kRendererFlagSatMid      = (1<<3),
  kRendererFlagSatEnd      = (1<<4),
  kRendererFlagSatZero     = (1<<5),
  kRendererFlagUseAlpha    = (1<<6),
  kRendererFlagBakeRGB     = (1<<7),
  kRendererFlagAddRGB      = (1<<8),
  kRendererFlagPoint       = (1<<9),
  kRendererFlagLine        = (1<<10),
  kRendererFlagGradated    = (1<<11),
  kRendererFlagRotScale    = (1<<12),
  kRendererFlagLarge       = (1<<13),

  kRendererFlagGeneric = kRendererFlagTranslucent | kRendererFlagBright | kRendererFlagSatMid | kRendererFlagSatEnd | kRendererFlagSatZero | kRendererFlagRotScale | kRendererFlagLarge,
};

sRendererInfo aRendererInfo[kSpriteRendererMax];
unsigned long ptrChecksum;
int screenW, screenH;

RASTER_INFO rinfo, rinfo2, rinfo3;
RASTER_INFO minfo[MAX_MPES];

SPRITE spriteBlock[MAX_SPRITES];
int autoDisplayListIndex;
//SPRITE spriteBlock[2][MAX_SPRITES];
//int sprIndexWork = 0;
//SPRITE spriteEmpty[MAX_SPRITES];
PriorityQueue freeSprites;
PriorityQueue usedSprites;
#ifdef MULTI_LIST
int numDisplayLists = 0;
PriorityQueue aDisplayList[MAX_DISPLAY_LISTS];
#else
PriorityQueue displayList;
#endif

//int startMPE,endMPE;
int usedMPEs, numMPEs;
volatile long MPEMask;
long idleMask;
int sliceH;
int sprFlags;
int libspritePrintSprites = 0;
static int maxSpritesUsed = 0;

static int clrMethod = kClearColor, clrParam1, clrParam2, clrParam3;

int delay;

int SPRCommHandler(int,int,int,int,int,int,int,int);

int GetTGASize(unsigned char *tga, long *h, long *w);
int ReadTGA(unsigned char *tga, long dmaflags, void *base,
	    int xOutOffset, int yOutOffset, unsigned long *clut,long tcolRGB);
int checkAndAllocateDisplayList(int displayListIndex);

static int offsetX = 0;
static int offsetY = 0;

// =================================================================================================

#include "queue.c"

// =================================================================================================

void SPRFooLinkIt(void)
{
	int dummy1;
	dummy1 = SpriteBase;
}

int countElements(PriorityQueue *queue)
{
  PriorityQueueMember *qMember;
  int count = 0;

  for (qMember = queue->list; qMember; qMember = qMember->next) {
    count++;
  }

  return count;
}

void checkQueue(PriorityQueue *queue, char *str1, char *str2)
{
  int i;
  int count = 0;
  PriorityQueueMember *qMember;

  for (qMember = queue->list; qMember; qMember = qMember->next) {
    for (i = 0; i < MAX_SPRITES; i++) {
      if (&spriteBlock[i].q == qMember) {
	break;
      }
    }

    if (i >= MAX_SPRITES) {
      printf("Could not find queue member %d in %s (%s)\n", count, str1, str2);
    }
    count++;
  }
}

int SPRCountAllElements(int mode, char *str1, char *str2)
{
  int i;
  int count;
  char tmpStr[50];

  switch (mode) {
    case 0:
      printf("\nCounting elements in each queue\n");
      count = countElements(&freeSprites);
      printf("Free Sprites: %d\n", count);
      count = countElements(&usedSprites);
      printf("Used Sprites: %d\n", count);

      for (i = 0; i < MAX_DISPLAY_LISTS; i++) {
	count = countElements(&aDisplayList[i]);
	printf("List #%d Sprites: %d\n", i, count);
      }
      break;
    case 1:
      count = 0;
      count += countElements(&freeSprites);
      count += countElements(&usedSprites);
      for (i = 0; i < MAX_DISPLAY_LISTS; i++) {
	count += countElements(&aDisplayList[i]);
      }
      if (count != MAX_SPRITES) {
	printf("Total elements=%d  (%s%s)\n", count, str1, str2);
      }
      return (count == MAX_SPRITES) ? 1 : 0;
      break;
    case 2:
      checkQueue(&freeSprites, "freeSprites", str1);
      checkQueue(&usedSprites, "usedSprites", str1);
      for (i = 0; i < MAX_DISPLAY_LISTS; i++) {
	sprintf(tmpStr, "aDisplayList[%d]", i);
	checkQueue(&aDisplayList[i], tmpStr, str1);
      }
      break;
  }

  return 0;
}

void SPRFill(int initx, int inity, int wide, int high, int color)
{
  int x, y;
  int lastx, lasty;

  lastx = initx + wide;
  lasty = inity + high;

  for ( x = initx; x < lastx; x += 8 )
  {
    for ( y = inity; y < lasty; y += 8 )
    {
      _raw_plotpixel( rinfo.dmaflags, (void*) rinfo.dest, ( 8 << 16 ) | x, ( 8 << 16 ) | y, color );
    }
  }
}

void transferRenderer(int index, char *addr, int size, int flags)
{
  int i;
  char *ptr;
  void *localScratch;
  int debug = 0;

  if (debug) printf("LIBSPRITE transferRenderer(%d %08X %d %08X)\n",
		    index, (unsigned int) addr, size, flags);

  localScratch = _MemLocalScratch(0);
  //  if (debug) printf("\nlocalScratch=%08X", (unsigned int) localScratch);
  ptr = _MemAlloc(size + 31, 0, kMemSDRAM);  // round up to 32 bytes
  if (debug) printf("LIBSPRITE transferRenderer(): ptr=%08X\n", (unsigned int) ptr);
  if ( ptr != NULL )
  {
    aRendererInfo[index].flags = flags;
    aRendererInfo[index].ptr = ((long) ptr & 0x007FFFFF) | (((size+3)>>2) << 23);
    if (debug) printf("LIBSPRITE trnasferRenderer(): ptr/size=%08X\n",
		      (int) aRendererInfo[index].ptr);
    fflush(stdout);
    for (i = 0; i < size; i += 32, addr += 32, ptr += 32)
    {
      //      if (debug) printf("\nTransfering 32 bytes from %08X to %08X to %08X",
      //			(unsigned int) addr, (unsigned int) localScratch, (unsigned int) ptr);
      _DMALinear((1<<13)|(32<<16), addr, localScratch);  // read from system ram
      _DMALinear((0<<13)|(32<<16), ptr,  localScratch);  // write to main ram
    }
  }
  else
  {
    aRendererInfo[index].ptr = 0;
  }
  
  if (debug) fflush(stdout);
}

//int SPRInit(int startmpe, int endmpe, int sliceHeight, int flags)
int SPRInit(unsigned long mask, int sliceHeight, int flags)
{
  int i;

  for (i = 0; i < kSpriteRendererMax; i++)
  {
    aRendererInfo[i].flags = 0;
    aRendererInfo[i].ptr   = 0;
    aRendererInfo[i].cnt   = 0;
  }

  // Sprite renderers
  transferRenderer(kSpriteSimple,               (char *) pixgen0_start,  (long) pixgen0_size, 0);
  transferRenderer(kSpriteSimpleTrans,          (char *) pixgen1_start,  (long) pixgen1_size, 0);
  transferRenderer(kSpriteInterpolatedTrans,    (char *) pixgen6_start,  (long) pixgen6_size, 0);
  transferRenderer(kSpriteInterpolated,         (char *) pixgen4_start,  (long) pixgen4_size, 0);

  transferRenderer(kSpriteYarTp,                (char *) spTp_start,     (long) spTp_size,
		   kRendererFlagTransparent |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  
  transferRenderer(kSpriteYarTpBrightSimple,    (char *) spTpBS_start,   (long) spTpBS_size,
		   kRendererFlagTransparent |
		   kRendererFlagBright      |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTpBright,          (char *) spTpB_start,    (long) spTpB_size,
		   kRendererFlagTransparent |
		   kRendererFlagBright      |
		   kRendererFlagSatEnd      |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTpBrightAddRGB,    (char *) spTpBP_start,   (long) spTpBP_size,
		   kRendererFlagTransparent |
		   kRendererFlagBright      |
		   kRendererFlagSatEnd      |
		   kRendererFlagAddRGB      |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  
  transferRenderer(kSpriteYarTlNoSat,           (char *) spTl_start,     (long) spTl_size,
		   kRendererFlagTranslucent |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlNoSatAlpha,      (char *) spTlA_start,    (long) spTlA_size,
		   kRendererFlagTranslucent |
		   kRendererFlagUseAlpha    |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlNoSatRGBAlpha,   (char *) spTlRA_start,   (long) spTlRA_size,
		   kRendererFlagTranslucent |
		   kRendererFlagBakeRGB     |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlNoSatAddRGBAlpha,(char *) spTlPA_start,   (long) spTlPA_size,
		   kRendererFlagTranslucent |
		   kRendererFlagAddRGB      |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlNoSatRGBAddRGBAlpha, (char *) spTlRPA_start,   (long) spTlRPA_size,
		   kRendererFlagTranslucent |
		   kRendererFlagBakeRGB     |
		   kRendererFlagAddRGB      |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  
  transferRenderer(kSpriteYarTlSatEnd,          (char *) spTlE_start,    (long) spTlE_size,
		   kRendererFlagTranslucent |
		   kRendererFlagSatEnd      |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlSatEndRGB,       (char *) spTlER_start,   (long) spTlER_size,
		   kRendererFlagTranslucent |
		   kRendererFlagSatEnd      |
		   kRendererFlagBakeRGB     |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlSatEndAlpha,     (char *) spTlEA_start,   (long) spTlEA_size,
		   kRendererFlagTranslucent |
		   kRendererFlagSatEnd      |
		   kRendererFlagUseAlpha    |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  
  transferRenderer(kSpriteYarTlSatMidEnd,       (char *) spTlME_start,   (long) spTlME_size,
		   kRendererFlagTranslucent |
		   kRendererFlagSatMid      |
		   kRendererFlagSatEnd      |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlSatMidEndAlpha,  (char *) spTlMEA_start,  (long) spTlMEA_size,
		   kRendererFlagTranslucent |
		   kRendererFlagSatMid      |
		   kRendererFlagSatEnd      |
		   kRendererFlagUseAlpha    |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  
  transferRenderer(kSpriteYarTlSatZero,         (char *) spTlZ_start,    (long) spTlZ_size,
		   kRendererFlagTranslucent |
		   kRendererFlagSatZero     |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlSatZero_RGB,     (char *) spTlZR_start,   (long) spTlZR_size,
		   kRendererFlagTranslucent |
		   kRendererFlagSatZero     |
		   kRendererFlagBakeRGB     |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlSatEndZero,      (char *) spTlEZ_start,   (long) spTlEZ_size,
		   kRendererFlagTranslucent |
		   kRendererFlagSatEnd      |
		   kRendererFlagSatZero     |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  transferRenderer(kSpriteYarTlSatEndZeroAlpha, (char *) spTlEZA_start,  (long) spTlEZA_size,
		   kRendererFlagTranslucent |
		   kRendererFlagSatEnd      |
		   kRendererFlagSatZero     |
		   kRendererFlagUseAlpha    |
		   kRendererFlagRotScale    |
		   kRendererFlagLarge
		   );
  
  transferRenderer(kSpriteYarAll,               (char *) pixyar2X_start, (long) pixyar2X_size,
		   kRendererFlagGeneric
		   );

  // Points & lines
  transferRenderer(kSpritePoint, (char *) spPoint_start,  (long) spPoint_size,
		   kRendererFlagPoint
		   );
  transferRenderer(kSpriteLine,  (char *) spLine_start,   (long) spLine_size,
		   kRendererFlagLine
		   );
  transferRenderer(kSpriteGLine, (char *) spGLine_start,  (long) spGLine_size,
		   kRendererFlagLine |
		   kRendererFlagGradated
		   );

  // Non-rotated, non-scaled, small sprites
  transferRenderer(kSpriteSimpleTp, (char *) spSTp_start,  (long) spSTp_size,
		   kRendererFlagTransparent
		   );
  
  // Clear renderers
  transferRenderer(kClearColor,    (char *) clrColor_start, (long) clrColor_size, 0);
  transferRenderer(kClearCopyFade, (char *) clrCF_start,    (long) clrCF_size,    0);
  transferRenderer(kClearCopyTile, (char *) clrCT_start,    (long) clrCT_size,    0);
  transferRenderer(kClearStars,    (char *) clrStars_start, (long) clrStars_size, 0);
  
  //  startMPE = startmpe;
  //  endMPE   = endmpe;

  // Get the total number of MPEs
  usedMPEs = mask;
  numMPEs  = 0;
  for (; mask; mask >>= 1)
  {
    numMPEs += mask & 0x1;
  }
	 
  sliceH   = sliceHeight;
  sprFlags = flags;

  //  for(i = startMPE; i <= endMPE; i++) {
  for(i = 0; i < 32; i++ )
  {
    if ( usedMPEs & ( 1 << i ) )
    {
      MPEMask |= (1<<i);
      _MPELoad(i, (void *)0x20300000, spritec_start, (long) spritec_size);
      _MPELoad(i, (void *)0x20100000, sprited_start, (long) sprited_size);
      _MPERun (i, (void *)0x20300000);
    }
  }
  idleMask = MPEMask;

  //  sprIndexWork = 0;

  //  QInitMem(spriteBlock[sprIndexWork], MAX_SPRITES, sizeof(SPRITE));
  //  QInit(&freeSprites, (PriorityQueueMember *) spriteBlock[sprIndexWork]);
  //  QInitMem(&spriteBlock, MAX_SPRITES, sizeof(SPRITE));
  QInitMem(&spriteBlock[0].q, MAX_SPRITES, sizeof(SPRITE));
  QInit(&freeSprites, (PriorityQueueMember *) &spriteBlock[0].q);
  QInit(&usedSprites, 0L);
#ifdef MULTI_LIST
  for (i = 0; i < MAX_DISPLAY_LISTS; i++) {
    QInit(&aDisplayList[i], 0L);
  }
#else
  QInit(&displayList, 0L);
#endif
  for (i = 0; i < MAX_SPRITES; i++) {
    //    spriteBlock[sprIndexWork][i].parent = &freeSprites;
    spriteBlock[i].parent = &freeSprites;
  }

  //  memcpy(spriteEmpty, spriteBlock[0], sizeof(SPRITE) * MAX_SPRITES);
  //  memcpy(spriteEmpty, spriteBlock, sizeof(SPRITE) * MAX_SPRITES);
  autoDisplayListIndex = 0;
    
  _IntSetVector(kIntrCommRecv, SPRCommHandler);
  return 0;
}

int SPRReset()
{
  int i;

  printf("LIBSPRITE SPRReset()\n");
  
  //  QInitMem(spriteBlock[sprIndexWork], MAX_SPRITES, sizeof(SPRITE));
  //  QInit(&freeSprites, (PriorityQueueMember *) spriteBlock[sprIndexWork]);
  QInitMem(&spriteBlock, MAX_SPRITES, sizeof(SPRITE));
  QInit(&freeSprites, (PriorityQueueMember *) &spriteBlock);
  QInit(&usedSprites, 0L);

  for (i = 0; i < MAX_SPRITES; i++) {
    //    spriteBlock[sprIndexWork][i].parent = &freeSprites;
    spriteBlock[i].parent = &freeSprites;
  }

#ifdef MULTI_LIST
  for (i = 0; i < MAX_DISPLAY_LISTS; i++) {
    QInit(&aDisplayList[i], 0L);
  }
#else
  QInit(&displayList, 0L);
#endif
  
  printf("LIBSPRITE SPRReset() ends\n");
  
  return 0;
}

void SPRRemoveStickySprite( SPRITE *spr, int displayListIndex )
{
  if ( spr != NULL )
  {
    // Remove the sticky flag
    spr->q.flags &= ~kSprHintSticky;
  }

  /*
  // Remove the sprite from the display list, if present
  if ( spr->parent == &aDisplayList[displayListIndex] )
  {
    QRemove( &aDisplayList[displayListIndex], &spr->q );
    QAdd( &freeSprites, &spr->q, -1 );
    spr->parent = &freeSprites;
  }
  */
}

void SPRClearStickySprites( int displayListIndex )
{
  int i;

  for (i = 0; i < MAX_SPRITES; i++ )
  {
    if ( spriteBlock[i].parent == &aDisplayList[displayListIndex] )
    {
      if  ( ( spriteBlock[i].q.flags & kSprHintSticky ) != 0 )
      {
	// Remove sticky flag so this sprite is removed next time.
	// Do not actually remove the sprite because it might be in the process of drawing.
	spriteBlock[i].q.flags &= ~kSprHintSticky;
      }
      else
      {
	//	printf( "%08X: Removing sticky sprite from display list %d\n", (unsigned int) &spriteBlock[i], displayListIndex );
      }
    }
  }
}

int SPRClearDisplayList( int displayListIndex )
{
  int i;
  int count = 0;
  int debug = FUNC_TRACE;

  if ( debug != 0 )
  {
    printf( "LIBSPRITE SPRClearDisplayList(displayListIndex=%d)\n", displayListIndex );
  }
  
#ifdef MULTI_LIST
  if ( checkAndAllocateDisplayList( displayListIndex ) == 0 )
  {
    return -1;
  }
#endif

  // Remove sprites from the display list and put them in the free list
  for (i = 0; i < MAX_SPRITES; i++)
  {
#ifdef MULTI_LIST
    if ( spriteBlock[i].parent == &aDisplayList[displayListIndex] )
    {
      if  ( ( spriteBlock[i].q.flags & kSprHintSticky ) == 0 )
      {
	QRemove( &aDisplayList[displayListIndex], &spriteBlock[i].q );
	QAdd( &freeSprites, &spriteBlock[i].q, -1 );
	spriteBlock[i].parent = &freeSprites;
	count++;
      }
      else
      {
	//	printf( "%08X: Not removing sprite due to sticky bit\n", (unsigned int) &spriteBlock[i] );
      }
    }
#else
    if ( spriteBlock[i].parent == &displayList )
    {
      QRemove( &displayList, &spriteBlock[i].q );
      QAdd( &freeSprites, &spriteBlock[i].q, -1 );
      &spriteBlock[i].parent = &freeSprites;
    }
#endif
  }

#ifdef MULTI_LIST
  // Shouldn't need to do this because QRemove should handle it
  //  QInit( &aDisplayList[displayListIndex], 0L );
#else
  QInit( &displayList, 0L );
#endif

  if (debug) printf("LIBSPRITE SPRClearDisplayList():  Removed sprites=%d\n", count);
  
  return 0;
}

void SPRPrintRendererCounters()
{
  int i;

  printf("Sprite types: ");
  for (i = 0; i < kSpriteRendererMax; i++)
  {
    if ( aRendererInfo[i].cnt != 0 )
    {
      printf("%d=%d ", i, aRendererInfo[i].cnt);
    }
  }
  printf("\n");
}

void SPRResetRendererCounters()
{
  int i;
  for (i = 0; i < kSpriteRendererMax; i++)
  {
    aRendererInfo[i].cnt = 0;
  }
}

int SetDestScreen(void *scr, long dmaflags, int minx, int miny, int maxx, int maxy)
{
  int i,h,sh,y;

  rinfo3 = rinfo2;
  rinfo2 = rinfo;
  
  rinfo.dmaflags   = dmaflags;
  rinfo.dest       = scr;
  rinfo.clip_max_x = maxx;
  rinfo.clip_max_y = maxy;
  rinfo.clip_min_x = minx;
  rinfo.clip_min_y = miny;

  screenW = maxx - minx + 1;
  screenH = maxy - miny + 1;
  
  h=maxy-miny+1;
  sh=h/numMPEs;
  y=miny;
  for(i = 0; i < 32; i++) {
    if (usedMPEs & (1<<i)) {
      minfo[i].dmaflags=dmaflags;
      minfo[i].dest=scr;
      minfo[i].clip_min_x=minx;
      minfo[i].clip_max_x=maxx;
      minfo[i].clip_min_y=y;
      minfo[i].clip_max_y=y+sh-1;

      y+=sh;
    }
  }
  return 0;
}

int SPRSetDestScreen2(void *scr, long dmaflags, int minx, int miny, int maxx, int maxy,
		      int clrMethod, int clrParam1, int clrParam2, int clrParam3)
{
  SetDestScreen( scr, dmaflags, minx, miny, maxx, maxy );
  rinfo.renderer  = aRendererInfo[clrMethod].ptr;
  rinfo.clrParam1 = clrParam1;
  rinfo.clrParam2 = clrParam2;
  rinfo.clrParam3 = clrParam3;
  return 0;
}

int SPRSetDestScreen(void *scr, long dmaflags, int minx, int miny, int maxx, int maxy, int bgColor)
{
  return SPRSetDestScreen2( scr, dmaflags, minx, miny, maxx, maxy, kClearColor, bgColor, 0, 0 );
}

/*
   Sets up a TGA image to be usable as sprite source. The TGA is converted to either
   a 16 bpp or 32 bpp internal pixmap. The pixmap is setup in SDRAM. SDRAM memory is
   allocated via _MemAlloc
   
   tga:  TGA image
   mode: 0 = 16 bbp, 1 = 32 bpp 

*/

int SPRInstallTGAImage(char *tga, int mode, SPR_IMAGE_INFO *info,int transColorRGB)
{
	char *scr;
	long width,height,dmafl,type;
	
	GetTGASize(tga,&width,&height);
	
	type  = mode ? 4 : 2;  /* depth in bytes and DMA pixel type are conveniently the same !*/
	
	scr=_MemAlloc(width*height*type,512,kMemSDRAM);
	dmafl= (((width/8)<<16) | (type<<4) | DMA_PIXEL_WRITE | DMA_CLUSTER_BIT);
	
	ReadTGA(tga,dmafl,scr,0,0,0,transColorRGB);
	
	info->img = scr;
	info->dmaflags = dmafl | (1<<13);
	info->width = width;
	info->height = height;
	
	return 0;
}

/*
   Initializes a SPR_IMAGE_INFO structure with user defined values

*/

int SPRSetSourceImage(char *scr, int dmafl, int width, int height, SPR_IMAGE_INFO *info)
{
	info->img = scr;
	info->dmaflags = dmafl | (1<<13);
	info->width = width;
	info->height = height;
	
	return 0;
}


/*
    Creates a sprite. A sprite is defined by giving a rectangular area
    in a sprite source image (installed via SPRInstallTGAImage).
    
    The created sprite is not yet in the the display list and therefore invisible!
    
    Returns a sprite handle
*/

SPRITE* SPRCreateSprite(SPR_IMAGE_INFO *info,int x, int y, int w, int h)
{
  //  SPRITE* retVal;
  SPRITE *newspr;
  //  long usec, usecPrev;

  //  _TimeElapsed(NULL, &usecPrev);
  
  newspr = (SPRITE*) QGetHead(&freeSprites);

  if ( newspr != NULL )
  {
    newspr = (SPRITE *) (((void*) newspr) - 4); /* subtract 4 for the "parent" pointer */
    /* memset(newspr,0,sizeof(SPRITE)); */
    newspr->src_x      = x<<16;
    newspr->src_y      = y<<16;
    newspr->w          = w;
    newspr->h          = h;
    newspr->source     = info->img;
    newspr->dmaflags   = info->dmaflags;
    newspr->tint       = 0x40404000;
    newspr->transColor = 0x10808000;
    newspr->q.priority = 0;
    newspr->parent     = &usedSprites;

    QAdd( &usedSprites, &newspr->q, -1 );
    newspr->parent = &usedSprites;

    return newspr;
  }

  printf( "LIBSPRITE ERROR: Ran out of sprites?  (max=%d)\n", MAX_SPRITES );
  SPRCountAllElements(0, NULL, NULL);
  SPRCountAllElements(1, "SPRCreateSprite", " end2");
  SPRCountAllElements(2, NULL, NULL);

  return 0;
/*
  SPRCreateSpriteMac(retVal, info, x, y, w, h);
  
  _TimeElapsed(NULL, &usec);
  if (usec < usecPrev) usec += 1000000;
  usec -= usecPrev;
  delay += usec;

  return retVal;
*/
}

SPRITE* SPRAddPoint(int x, int y, int color, int depth, int displayListIndex)
{
  PriorityQueueMember *qMember;
  sPoint *pt;
  int type = kSpritePoint;
  int i;
  int debug = 0;

  if (debug) printf("SPRAddPoint(%d, %d, %08X, %d, %d)\n", x, y, color, depth, displayListIndex);

  x += offsetX;
  y += offsetY;

  if ( checkAndAllocateDisplayList( displayListIndex ) == 0 )
  {
    return 0;
  }

  color |= kSprHintRenderImm;// | kSprHintDebug;

  // First search for a member that already matches the same color and depth
  for ( qMember = aDisplayList[displayListIndex].list; qMember; qMember = qMember->next )
  {
    // Create pointer to this sprite
    pt = (sPoint *) ((void *) qMember - 4);

    // Look for points
    if ( pt->rendererPtr == aRendererInfo[type].ptr )
    {
      if ( debug != 0 )
      {
	printf( "SPRAddPoint() - Found point structure (depth=%d color=%08X)\n",
		(int) pt->q.priority, (unsigned int) pt->color );
      }

      // See if the depth and color matches
      if ( ( pt->q.priority == depth ) && ( color == pt->color ) )
      {
	if ( debug != 0 )
	{
	  printf( "SPRAddPoint() - Color and depth match\n" );
	}
	
	// Now see if there's room in this structure for one more point
	if ( pt->coord[MAX_POINTS-1] == UNUSED )
	{
	  // Find the first empty slot
	  for ( i = 1; pt->coord[i] != UNUSED; i++ );

	  if ( i >= MAX_POINTS )
	  {
	    printf( "SPRAddPoint() WTF?\n" );
	  }

	  if ( debug != 0 )
	  {
	    printf( "SPRAddPoint() - Unused slot %d\n", i );
	  }
	  
	  // Save the new coordinate and return
	  pt->coord[i] = (y << 16) | x;
	  if ( debug != 0 )
	  {
	    printf("SPRAddPoint() ends\n");
	  }
	  return (SPRITE*) pt;
	}
	else
	{
	  if ( debug != 0 )
	  {
	    printf( "SPRAddPoint() - No unused slots\n" );
	  }
	}
      }
    }
  }

  if ( debug != 0 )
  {
    printf( "SPRAddPoint() - Creating new point structure\n" );
  }
  
  // If we got here then we didn't find an existing point structure that we can use.
  // Need to create one.
  pt = (sPoint*) QGetHead( &freeSprites ); // subtract 4 for the "parent" pointer
  
  if ( pt != NULL )
  {
    pt = (sPoint*) ( ( (void*) pt ) - 4 );
    pt->rendererPtr = aRendererInfo[type].ptr;
    pt->color = color;
    pt->coord[0] = ( y << 16 ) | x;
    pt->q.priority = depth;
    
    aRendererInfo[type].cnt++;

    for ( i = 1; i < MAX_POINTS; i++ )
    {
      pt->coord[i] = UNUSED;
    }
  
    QAdd( &aDisplayList[displayListIndex], &pt->q, sprFlags & SPR_FLAG_ADD_REVERSE );
    pt->parent = &aDisplayList[displayListIndex];
    if ( debug != 0 )
    {
      printf( "SPRAddPoint() ends\n" );
    }
    return (SPRITE*) pt;
  }

  printf( "SPRAddPoint failed!\n" );

  return NULL;
}

SPRITE* SPRAddLine( int x0, int y0, int x1, int y1, unsigned int color1, unsigned int color2, 
		    int depth, int displayListIndex, int flags )
{
  PriorityQueueMember *qMember;
  sLine *ln;
  sGLine *gln;
  int type = (color1 == color2) ? kSpriteLine : kSpriteGLine;
  int dx, dy, x, y;
  unsigned long majorCoords, minorCoords;
  int dMinor_dMajor;
  int diffY, diffCr, diffCb;
  int i;
  int debug = 0;

  if (_Controller[1].buttons & JOY_NUON) {
    //    color |= kSprHintDebug;
    //    debug = 1;
  }
  
  if ( debug != 0 )
  {
    printf("SPRAddLine(%d, %d, %d, %d, %08X, %08X, %d, %d)\n",
	   x0, y0, x1, y1, color1, color2, depth, displayListIndex);
  }

  x0 += offsetX;
  y0 += offsetY;
  x1 += offsetX;
  y1 += offsetY;

  if ( checkAndAllocateDisplayList( displayListIndex ) == 0 )
  {
    return 0;
  }

  color1 |= kSprHintRenderImm;// | kSprHintDebug;
  color2 |= kSprHintRenderImm;// | kSprHintDebug;
  /*
  if (type == kSpriteGLine) {
    color1 |= kSprHintDebug;
    color2 |= kSprHintDebug;
  }
  */
  dx = x0 - x1;
  dy = y0 - y1;

  if ( abs( dx ) >= abs( dy ) )
  {
    // X is the major axis, Y is minor
    if ( x1 < x0 )
    {
      x  = x1;
      x1 = x0;
      x0 = x;
      y  = y1;
      y1 = y0;
      y0 = y;
      x      = color1;
      color1 = color2;
      color2 = x;
    }
    majorCoords = ( x1 << 16 ) | x0;
    minorCoords = ( y1 << 16 ) | y0;
    // Clear bottom bit (flag) to tell renderer not to swap major/minor
    dMinor_dMajor = ( ( dy << 16 ) / dx ) & ~0x1;
  }
  else
  {
    // Y is the major axis, X is minor
    if ( y1 < y0 )
    {
      x  = x1;
      x1 = x0;
      x0 = x;
      y  = y1;
      y1 = y0;
      y0 = y;
      x      = color1;
      color1 = color2;
      color2 = x;
    }
    majorCoords = ( y1 << 16 ) | y0;
    minorCoords = ( x1 << 16 ) | x0;
    //    if (majorCoords == UNUSED) {
    //      majorCoords = UNUSED ^ 0x1;
    //    }
    // Set bottom bit (flag) to tell renderer to swap major/minor
    dMinor_dMajor = ( ( dx << 16 ) / dy ) | 0x1;
  }

  // Get the amount that each color component must step with each pixel in order to transition
  // from one color to the other.
  if ( color1 != color2 )
  {
    // Treat diffY differently because we want to shift before masking in order to preserve the sign
    diffY  = ( ( color2 >>  2 ) - ( color1 >>  2 ) ) & 0xFFC00000;
    diffCr = ( ( color2 & 0x00FF0000 ) - ( color1 & 0x00FF0000 ) ) << 6;
    diffCb = ( ( color2 & 0x0000FF00 ) - ( color1 & 0x0000FF00 ) ) << 14;
    x = ( majorCoords >> 16 ) - ( majorCoords & 0xFFFF );
    diffY  /= x;
    diffCr /= x;
    diffCb /= x;
  }

  // First search for a member that already matches the same color and depth
  for ( qMember = aDisplayList[displayListIndex].list; qMember; qMember = qMember->next )
  {
    // Create pointer to this line/gline structure
    ln  = (sLine  *) ((void *) qMember - 4);
    gln = (sGLine *) ((void *) qMember - 4);

    // Look for lines of the same depth
    if ( ( ln->rendererPtr == aRendererInfo[type].ptr ) && ( ln->q.priority == depth ) )
    {
      if ( debug != 0 )
      {
	printf("SPRAddLine() - Found line structure (depth=%d color=%08X)\n",
	       (int) ln->q.priority, (unsigned int) ln->color);
      }
      
      // See if color(s) match
      switch ( type )
      {
	case kSpriteLine:
	  if ( color1 == ln->color )
	  {
	    if ( debug != 0 )
	    {
	      printf("SPRAddLine() - Single color matches\n");
	    }
	    
	    // Now see if there's room in this structure for one more line
	    if ( ln->coord[MAX_LINES-1].majorCoords == UNUSED )
	    {
	      // Find the first empty slot
	      for (i = 1; ln->coord[i].majorCoords != UNUSED; i++);

	      if (i >= MAX_LINES) {
		printf("SPRAddLine() WTF?\n");
	      }

	      if (debug) printf("SPRAddLine() - Unused line slot %d", i);
	  
	      ln->coord[i].majorCoords = majorCoords;
	      ln->coord[i].minorCoords = minorCoords;
	      ln->coord[i].dMinor_dMajor = dMinor_dMajor;
	      if (debug) printf(" - %d %d %08X %08X %08X\n", dx, dy,
				(unsigned int) ln->coord[i].majorCoords,
				(unsigned int) ln->coord[i].minorCoords,
				(unsigned int) ln->coord[i].dMinor_dMajor);
	      if (debug) printf("SPRAddLine() ends\n");
	      return (SPRITE*) ln;
	    } else {
	      if (debug) printf("SPRAddLine() - No unused line slot\n");
	    }
	  }
	  break;

	case kSpriteGLine:
	  // See if there's room in this structure for one more line
	  if (gln->data[MAX_GLINES-1].majorCoords == UNUSED) {
	    // Find the first empty slot
	    for (i = 0; gln->data[i].majorCoords != UNUSED; i++);
	    
	    if (i >= MAX_GLINES) {
	      printf("SPRAddLine() WTF?  i=%d\n", i);
	    }

	    if (debug) printf("SPRAddLine() - Unused gline slot %d", i);
	  
	    gln->data[i].majorCoords   = majorCoords;
	    gln->data[i].minorCoords   = minorCoords;
	    gln->data[i].dMinor_dMajor = dMinor_dMajor;
	    gln->data[i].colorStart    = color1;
	    gln->data[i].colorStepY    = diffY;
	    gln->data[i].colorStepCr   = diffCr;
	    gln->data[i].colorStepCb   = diffCb;
	    if (debug) printf(" - %d %d %08X %08X %08X\n", dx, dy,
			      (unsigned int) gln->data[i].majorCoords,
			      (unsigned int) gln->data[i].minorCoords,
			      (unsigned int) gln->data[i].dMinor_dMajor);
	    if (debug) printf("   %08X %08X %08X %08X %08X\n", color1, color2, 
			      (unsigned int) diffY, 
			      (unsigned int) diffCr,
			      (unsigned int) diffCb);
	    if (debug) printf("SPRAddLine() ends\n");
	    return (SPRITE*) gln;
	  } else {
	    if (debug) printf("SPRAddLine() - No gline unused slot\n");
	  }
	  break;
	  
	default:
	  printf("SPRAddLine() Unrecognized type\n");
	  break;
      }
    }
  }

  // If we got here then we didn't find an existing line structure that we can use.
  // Need to create one.
  ln  = (sLine*) QGetHead(&freeSprites);
  
  if ( ln != NULL )
  {
    ln = (sLine*) ( ( (void*) ln ) - 4 ); // subtract 4 for the "parent" pointer
    ln->rendererPtr = aRendererInfo[type].ptr;
    ln->q.priority = depth;

    switch (type) {
      case kSpriteLine:
	if (debug) printf("SPRAddLine() - Creating new line structure");
  
	ln->color = color1;
	ln->coord[0].majorCoords = majorCoords;
	ln->coord[0].minorCoords = minorCoords;
	ln->coord[0].dMinor_dMajor = dMinor_dMajor;
	if (debug) printf(" - DX=%d DY=%d %08X %08X %08X\n", dx, dy,
			  (unsigned int) ln->coord[0].majorCoords,
			  (unsigned int) ln->coord[0].minorCoords,
			  (unsigned int) ln->coord[0].dMinor_dMajor);
	for (i = 1; i < MAX_LINES; i++) {
	  ln->coord[i].majorCoords   = UNUSED;
	  ln->coord[i].minorCoords   = UNUSED;
	  ln->coord[i].dMinor_dMajor = UNUSED;
	}
	break;

      case kSpriteGLine:
	if (debug) printf("SPRAddLine() - Creating new gline structure\n");
  
	gln = (sGLine*) ln;
	gln->hint = color1;
	gln->data[0].majorCoords   = majorCoords;
	gln->data[0].minorCoords   = minorCoords;
	gln->data[0].dMinor_dMajor = dMinor_dMajor;
	gln->data[0].colorStart    = color1;
	gln->data[0].colorStepY    = diffY;
	gln->data[0].colorStepCr   = diffCr;
	gln->data[0].colorStepCb   = diffCb;
	if (debug) printf("   DX=%d DY=%d %08X %08X %08X diffY=%d diffCr=%d diffCb=%d\n", dx, dy,
			  (unsigned int) gln->data[0].majorCoords,
			  (unsigned int) gln->data[0].minorCoords,
			  (unsigned int) gln->data[0].dMinor_dMajor,
			  diffY>>22, diffCr>>22, diffCb>>22);
	for (i = 1; i < MAX_GLINES; i++) {
	  gln->data[i].majorCoords   = UNUSED;
	  gln->data[i].minorCoords   = UNUSED;
	  gln->data[i].dMinor_dMajor = UNUSED;
	  gln->data[i].colorStart    = UNUSED;
	  gln->data[i].colorStepY    = UNUSED;
	  gln->data[i].colorStepCr   = UNUSED;
	  gln->data[i].colorStepCb   = UNUSED;
	}
	break;

      default:
	printf("SPRAddLine() Unrecognized type\n");
	break;
    }
    
    aRendererInfo[type].cnt++;

    QAdd(&aDisplayList[displayListIndex], &ln->q, sprFlags & SPR_FLAG_ADD_REVERSE);
    ln->parent = &aDisplayList[displayListIndex];
    if (debug) printf("SPRAddLine() ends\n");
    return (SPRITE*) ln;
  }

  printf("SPRAddLine failed!\n");

  return NULL;
}

/*
    Clones an existing sprite.
*/

SPRITE *SPRCloneSprite(SPRITE *s)
{
  SPRITE *newspr;

  newspr = (SPRITE *) ((void *) QGetHead(&freeSprites) - 4); // subtract 4 for the "parent" pointer
  
  if (newspr) {
    memcpy(newspr,s,sizeof(SPRITE));

    QAdd(&usedSprites, &newspr->q, sprFlags & SPR_FLAG_ADD_REVERSE);
    newspr->parent = &usedSprites;

    return newspr;
  }

  return 0;
}

/*
    Add a sprite created with SPRCreateSprite to the display list.
*/

int SPRAddSprite(SPRITE * sprite, int x, int y, int angle, int xscale, int yscale, int type,
		 int tc, int depth)
{
  if (sprite->parent != &usedSprites) {
    return -1;
  }

  QRemove(&usedSprites, &sprite->q);

  sprite->x          = x + offsetX;
  sprite->y          = y + offsetY;
  sprite->xscale     = xscale;
  sprite->yscale     = yscale;
  sprite->angle      = angle;
  sprite->trans      = type;
  sprite->transColor = tc;
  sprite->q.priority = depth;
#ifdef MULTI_LIST
  QAdd(&aDisplayList[0], &sprite->q, sprFlags & SPR_FLAG_ADD_REVERSE);
  sprite->parent     = &aDisplayList[0];
#else
  QAdd(&displayList, &sprite->q, sprFlags & SPR_FLAG_ADD_REVERSE);
  sprite->parent     = &displayList;
#endif
  sprite->rendererPtr = aRendererInfo[type & 0xFF].ptr;

  if ( aRendererInfo[type & 0xFF].ptr == 0 )
  {
    printf("\nLIBSPRITE ERROR:  Unimplemented sprite renderer #%d\n", type & 0xFF);
  }

  return 0;
}

int checkAndAllocateDisplayList(int displayListIndex)
{
  /*  
  int i;
  int debug = FUNC_TRACE;
  
  if (displayListIndex >= numDisplayLists) {
    if (debug) {
      printf("LIBSPRITE checkAndAllocateDisplayList(): Increasing display list to %d entries (old=%d)\n",
	     displayListIndex+1, numDisplayLists);
    }

    //    aDisplayList =(PriorityQueue*)realloc(aDisplayList,sizeof(PriorityQueue)*(displayListIndex+1));
    printf("*\n");
    aDisplayListPrev = aDisplayList;
    printf("*\n");
    
    aDisplayList = (PriorityQueue*) malloc(sizeof(PriorityQueue) * (displayListIndex+1));

    printf("*\n");
    if (!aDisplayList) {
      printf("\nLIBSPRITE ERROR in checkAndAllocateDisplayList()\n");
      printf("   Could not realloc display list array for %d entries\n", displayListIndex + 1);
      numDisplayLists = 0;
      if (aDisplayListPrev) free(aDisplayListPrev);
      return 0;
    }
    
    printf("*\n");
    for (i = 0; i < numDisplayLists; i++) {
      aDisplayList[i] = aDisplayListPrev[i];
    }
    printf("*\n");
    if (aDisplayListPrev) free(aDisplayListPrev);
    printf("*\n");
    

    // Initialize all the newly allocated display lists
    for (i = numDisplayLists; i <= displayListIndex; i++) {
      QInit(&aDisplayList[i], 0L);
    }
    numDisplayLists = displayListIndex + 1;
  }
  */

  if (displayListIndex >= MAX_DISPLAY_LISTS) {
    printf("LIBSPRITE ERROR in checkAndAllocateDisplayList(): displayListIndex(%d) > %d\n",
	   displayListIndex, MAX_DISPLAY_LISTS);
    return 0;
  }
  
  return 1;
}

int SPRGetYarozeType(SPRITE *sprite, int transFG, int transBG,
		     int spriteFlags, int displayListIndex)
{
  int type;
  int brightOn, brightSimple;
  int satToZero, satFG, satFinalPix;
  int maxFG, minFG, maxBG, minBG;
  int flags = 0;
  int hint = spriteFlags & ( kSprHintNoTransp | kSprHintDebug );
  int debugPrint = ( ( spriteFlags & kSprHintPrint ) || libspritePrintSprites ) ? 1 : 0;

  // See if we need to do RGB brightness scaling
  brightOn = ( ( sprite->tint & 0xFFFFFF00 ) == 0x80808000 ) ? 0 : 1;
    
  // If the RGB scales are less than 1.0 then things get easier
  brightSimple = brightOn;
  if ( ( ( sprite->tint >> 24 ) & 0xFF ) > 0x80 )
  {
    brightSimple = 0;
  }
  else if ( ( ( sprite->tint >> 16 ) & 0xFF ) > 0x80 )
  {
    brightSimple = 0;
  }
  else if ( ( ( sprite->tint >>  8 ) & 0xFF ) > 0x80 )
  {
    brightSimple = 0;
  }

  if ( sprite->addRGB != 0 )
  {
    flags |= kRendererFlagAddRGB;
    hint  |= kSprHintMatPrepOne;
  }
  if ( ( spriteFlags & kSprHintBakeRGB ) != 0 )
  {
    flags |= kRendererFlagBakeRGB;
  }

  // Translucency is indicated by a non-zero background scale
  if ( transBG != 0 )
  {
    // Translucent
    flags |= kRendererFlagTranslucent;
    
    if ( ( sprFlags & SPR_FLAG_USE_ALPHA ) != 0 )
    {
      flags |= kRendererFlagUseAlpha;
    }

    // Figure out what bells and whistles the renderer will need to accomodate this sprite.
    // First find the minimum and maximum the foreground and background pixels can be.
    maxFG = ( transFG < 0 ) ? 0 : ( ( brightOn && !brightSimple ) ? ( transFG << 1 ) : transFG );
    minFG = ( transFG > 0 ) ? 0 : ( ( brightOn && !brightSimple ) ? ( transFG << 1 ) : transFG );
    maxBG = ( transBG < 0 ) ? 0 : transBG;
    minBG = ( transBG > 0 ) ? 0 : transBG;

    // Use the min/max to determine what is necessary to construct the final pixel
    satFinalPix = ( ( maxFG + maxBG ) > ( 1 << 16 ) ) ? 1 : 0;
    satFG       = ( ( maxFG > ( 1 << 16 ) ) && ( abs( maxFG + maxBG ) >= ( 2 << 16 ) ) ) ? 1 : 0;
    satToZero   = ( ( transFG < 0 ) || ( transBG < 0 ) ) ? 1 : 0;

    // All translucent pixels must be broken down into FG & BG
    hint |= kSprHintMatPrepOne;
    
    //    type = kSpriteYarAll;  // temp

    if (satFG      ) flags |= kRendererFlagSatMid;
    if (satFinalPix) flags |= kRendererFlagSatEnd;
    if (satToZero  ) flags |= kRendererFlagSatZero;
    
    if ( debugPrint )
    {
      printf("%s ", satFinalPix ? "End" : "   ");
      printf("%s ", satFG       ? "Md" : "  ");
      printf("%s ", satToZero   ? "Zr" : "  ");
    }
  }
  else
  {
    // Not translucent
    
    if ( ( hint & kSprHintNoTransp ) != 0 )
    {
      // Not translucent nor transparent
    }
    else
    {
      // Not translucent, but transparent
      flags |= kRendererFlagTransparent;
    }
    
    if ( brightOn != 0 )
    {
      flags |= kRendererFlagBright;
      if ( brightSimple != 0 )
      {
	hint |= kSprHintMatPrepBoth;
      }
      else
      {
	flags |= kRendererFlagSatEnd;
	hint |= kSprHintMatPrepOne;
      }
    }
    
    
    if ( debugPrint != 0 )
    {
      printf( "%s ", (hint & kSprHintNoTransp) ? "  " : "Tp" );
      if ( brightOn != 0 )
      {
	printf( "Br%s ", brightSimple ? "Simp" : "    " );
      }
      else
      {
	printf( "%s ", (spriteFlags & kSprHintBakeYCrCb) ? "BrBake" : "      " );
      }
    }
    
  }

  // Check for simple sprites that can be handled more quickly.
  if ( ( sprite->xscale != (1<<16) ) || ( sprite->yscale != (1<<16) ) || ( sprite->angle != 0 ) )
  {
    flags |= kRendererFlagRotScale;
  }

  //  if ( ( sprite->w * sprite->h ) > 256 )
  if ( ( sprite->w * sprite->h ) > 400 )
  {
    flags |= kRendererFlagLarge;
  }

  // Now we know what attributes we need in the renderer.  See if it exists in our list.
  for ( type = 0; type < kSpriteRendererMax; type++ )
  {
    if ( aRendererInfo[type].flags == flags )
    {
      break;
    }
  }

  if ( type >= kSpriteRendererMax )
  {
    // Didn't find a perfect match so look for one that's a superset of what we need
    if ( debugPrint != 0 )
    {
      printf("ALT ");
    }
    for ( type = 0; type < kSpriteRendererMax; type++ )
    {
      if ( ( aRendererInfo[type].flags & flags ) == flags )
      {
	break;
      }
    }
  }

  if ( type >= kSpriteRendererMax )
  {
    if (debugPrint) printf(" **RENDERER NOT FOUND (flags=%03X)**\n", flags);
    return -1;
  }

  // Renderers that don't handle rotation and scaling have their immediate bit set
  if ( ( aRendererInfo[type].flags & kRendererFlagRotScale ) == 0 )
  {
    hint |= kSprHintRenderImm;// | kSprHintDebug;
  }
  
  if ( debugPrint != 0 )
  {
    printf( "%03X=%d", flags, type );
    printf( "\n" );
  }

  sprite->rendererPtr = aRendererInfo[type].ptr;
  sprite->tint       |= hint;

  if ( aRendererInfo[type].ptr == 0 )
  {
    printf("\nLIBSPRITE ERROR:  Unimplemented sprite renderer #%d\n", type);
  }

  return type;
}

int SPRAddSpriteYaroze(SPRITE *sprite, int x, int y, int angle, int xscale, int yscale, 
		       int transFG, int transBG, int scaleR, int scaleG, int scaleB,
		       unsigned long addRGB, int depth, int spriteFlags, int displayListIndex)
{
  int i;
  int bakeRGB = 0, bakeYCrCb = 0;
  int debugPrint = ( ( spriteFlags & kSprHintPrint ) || libspritePrintSprites ) ? 1 : 0;
  int debug = 0;
  PriorityQueueMember *qMember;
  int type;
  int retVal = 0;
  int newSprite = 1;  // assume this is a new sprite for now

#ifdef LIBSPRITE_CLIP
#include "clip.c"
#endif

  // Save the flags for later
  sprite->q.flags = spriteFlags;

  // Saturate the translucency values
  if ( transFG > ( 1<<16) ) transFG =  1<<16;
  if ( transFG < (-1<<16) ) transFG = -1<<16;
  if ( transBG > ( 1<<16) ) transBG =  1<<16;
  if ( transBG < (-1<<16) ) transBG = -1<<16;

  // Two negative scales will always lead to black pixels
  if ( ( transFG <= 0 ) && ( transBG <= 0 ) ) transFG = transBG = 0;

  // Saturate the RGB scales
  if ( scaleR >= ( 2 << 16 ) ) scaleR = ( 2 << 16 ) - 1;
  if ( scaleG >= ( 2 << 16 ) ) scaleG = ( 2 << 16 ) - 1;
  if ( scaleB >= ( 2 << 16 ) ) scaleB = ( 2 << 16 ) - 1;
  if ( scaleR <    0         ) scaleR = 0;
  if ( scaleG <    0         ) scaleG = 0;
  if ( scaleB <    0         ) scaleB = 0;

  bakeRGB   = ( spriteFlags & kSprHintBakeRGB   ) ? 1 : 0;
  bakeYCrCb = ( spriteFlags & kSprHintBakeYCrCb ) ? 1 : 0;
  
  // Grab the X/Y coordinates so we can print them
  sprite->x = x + offsetX;
  sprite->y = y + offsetY;

  if ( debugPrint != 0 )
  {
    printf( "XYWH=%3d,%3d %3d,%3d ", sprite->x, sprite->y, sprite->w, sprite->h );
    printf( "RGB=%0.2f %0.2f %0.2f",
	    (float) scaleR / (float) 0x10000,
	    (float) scaleG / (float) 0x10000,
	    (float) scaleB / (float) 0x10000 );
    printf( "%c ", ( bakeRGB || bakeYCrCb ) ? '*' : ' ' );
    printf( "FgBg=%5.2f,%5.2f ",
	    (float) transFG / (float) 0x10000,
	    (float) transBG / (float) 0x10000 );
  }

  // If the RGB brightness has already been baked in then clear them here so they don't get
  // applied twice.
  if ( bakeRGB != 0 )
  {
    scaleR = 1<<16;
    scaleG = 1<<16;
    scaleB = 1<<16;
  }
  
  // If we've included RGB, but kept the pixels in YCrCb then they aren't in RGB format so
  // clear that flag.
  if ( bakeYCrCb != 0 )
  {
    spriteFlags &= ~kSprHintBakeRGB;
  }

  // If we baked in the foreground translucency then make sure it isn't applied again
  // within the renderer.
  if ( ( bakeYCrCb || bakeRGB ) && ( transFG > 0 ) && ( ( sprFlags & SPR_FLAG_USE_ALPHA ) == 0 ) )
  {
    transFG = 1<<16;
  }
    
  sprite->xscale     = xscale;
  sprite->yscale     = yscale;
  sprite->angle      = angle;
  sprite->addRGB     = addRGB;
  sprite->transColor = 0x10808001;
  sprite->trans      = ( ( transFG >> 2 ) & 0xFFFF ) | ( ( transBG >> 2 ) << 16 );
  sprite->tint      |=
    ( ( scaleR & 0x1FE00 ) << 15 ) | ( ( scaleG & 0x1FE00 ) << 7 ) | ( ( scaleB & 0x1FE00 ) >> 1 );
  sprite->q.priority = depth;
  
  if ( sprite->parent != &usedSprites )
  {
    return -1;
  }

  if ( ( spriteFlags & kSprHintRenderer ) != 0 )
  {
    sprite->tint |= spriteFlags & 0xFF;
    type = -1;
    for ( i = 0; i < kSpriteRendererMax; i++ )
    {
      if ( aRendererInfo[i].ptr == sprite->rendererPtr )
      {
	type = i;
	if ( debugPrint != 0 )
	{
	  printf( "Renderer=%d Hints=%02X\n", i, (unsigned int) sprite->tint & 0xFF );
	}
	break;
      }
    }
  }
  else
  {
    type = SPRGetYarozeType( sprite, transFG, transBG, spriteFlags, displayListIndex );
  }

  if ( type == -1 )
  {
    printf( "Renderer type is -1\n" );
    return -1;
  }

  // Keep track of how many of each sprite is drawn
  aRendererInfo[type].cnt++;
  
  // Take specific action depending on the renderer type
  switch ( type )
  {
    case kSpriteSimpleTp:
      // Can't group multiple sticky sprites together in case one needs to be unstickified
      {
	sSpriteSimple *sp1, *sp2;
	
	// Get a pointer to the simple sprite and move the parameters around to fit
	sp1 = (sSpriteSimple*) sprite;
	
	if ( ( spriteFlags & kSprHintSticky ) == 0 )
	{
	  for ( qMember = aDisplayList[displayListIndex].list; qMember; qMember = qMember->next )
	  {
	    // Create pointer to this sprite
	    sp2 = (sSpriteSimple*) ( (void*) qMember - 4 );

	    if ( ( sp2->q.flags & kSprHintSticky ) != 0 )
	    {
	      // Cannot insert a sprite into a sticky structure - sticky sprites must stand alone
	      continue;
	    }

	    // Look for sprites that match on depth, source pointer, and source offsets.  We assume
	    // that the dmaflags and W,H also match.
	    if ( ( sp1->rendererPtr == sp2->rendererPtr ) &&
		 ( sp1->q.priority == sp2->q.priority ) && ( sp1->source == sp2->source ) &&
		 ( sp1->src_x == sp2->src_x ) && ( sp1->src_y == sp2->src_y ) )
	    {
	      if ( debug != 0 )
	      {
		printf( "%s - Found sprite structure (depth=%d, ptr=%08X, XY=%d,%d)\n",
			__func__, (int) sp1->q.priority, (unsigned int) sp1->source,
			(int) sp1->src_x, (int) sp1->src_y );
	      }
	    
	      // See if there's room in this structure for one more sprite
	      if ( sp2->aSprCoord[MAX_SPR_SIMPLE-1].x == (short) UNUSED16 )
	      {
		int i;
	      
		// Find the first empty slot
		for ( i = 1; ( sp2->aSprCoord[i].x != (short) UNUSED16 ) && ( i < MAX_SPR_SIMPLE ); i++ );
		
		if ( i >= MAX_SPR_SIMPLE )
		{
		  printf("%s WTF?\n", __func__);
		}
	      
		if ( debug != 0 )
		{
		  printf( "%s - Unused simple sprite slot %d", __func__, i );
		}
	      
		// Move the coordinate over to the existing sprite
		sp2->aSprCoord[i].x = sprite->x;
		sp2->aSprCoord[i].y = sprite->y;
		
		if ( debug != 0 )
		{
		  printf( " - %d,%d\n", sprite->x, sprite->y );
		}

		// We inserted this sprite's information into an existing sprite so tell
		// the caller to delete the original.
		retVal = -1;
		newSprite = 0;
		break;
	      }
	      else
	      {
		for ( i = 0; i < MAX_SPR_SIMPLE; i++ )
		{
		  if ( debug != 0 )
		  {
		    printf( "%s - %d: %d,%d\n",
			    __func__, i, sp2->aSprCoord[i].x, sp2->aSprCoord[i].y );
		  }
		}
		if ( debug != 0 )
		{
		  printf( "%s - No simple sprite unused slot\n", __func__ );
		}
	      }
	    }
	  }
	}
	
	// Check if this is the first sprite in this structure
	if ( newSprite == 1 )
	{
	  // Did not find an existing sprite with the same parameters - create a new one
	
	  // Store first coordinate in the proper place
	  sp1->aSprCoord[0].x = sprite->x;
	  sp1->aSprCoord[0].y = sprite->y;
	
/*
	printf( "%d,%d %08X %08X\n",
		sp1->x, sp1->y,
		((unsigned long*) &sp1->aSprCoord[0])[0],
		((unsigned long*) &sp1->aSprCoord[0])[0] );
	  
*/
	
	  // Clear out remaining coords the first time through
	  if ( debug != 0 )
	  {
	    printf("%s - Creating new simple sprite\n", __func__);
	  }
	  for ( i = 1; i < MAX_SPR_SIMPLE; i++ )
	  {
	    sp1->aSprCoord[i].x = UNUSED16;
	    sp1->aSprCoord[i].y = UNUSED16;
	  }
	}
	break;
      }
  }

  if ( newSprite == 1 )
  {
#ifdef MULTI_LIST
    if ( checkAndAllocateDisplayList( displayListIndex ) == 0 )
    {
      return -1;
    }
    QRemove( &usedSprites, &sprite->q );
    QAdd( &aDisplayList[displayListIndex], &sprite->q, sprFlags & SPR_FLAG_ADD_REVERSE );
    sprite->parent = &aDisplayList[displayListIndex];
#else
    QRemove( &usedSprites, &sprite->q );
    QAdd(&displayList, &sprite->q, sprFlags & SPR_FLAG_ADD_REVERSE);
    sprite->parent = &displayList;
#endif
  }

  return retVal;
}

//
// Combination of SPRCreateSprite and SPRAddSprite
//
SPRITE * SPRCreateAndAddSprite(SPR_IMAGE_INFO *info, int srcX, int srcY, int srcW, int srcH,
			       int x, int y, int angle, int xscale, int yscale, int type,
			       int tc, int depth)
{
  SPRITE *newspr;

  newspr = (SPRITE *) ((void *) QGetHead(&freeSprites) - 4); // subtract 4 for the "parent" pointer
  
  if (newspr) {
    newspr->src_x      = srcX<<16;
    newspr->src_y      = srcY<<16;
    newspr->w          = srcW;
    newspr->h          = srcH;
    newspr->source     = info->img;
    newspr->dmaflags   = info->dmaflags;

    newspr->x          = x;
    newspr->y          = y;
    newspr->xscale     = xscale;
    newspr->yscale     = yscale;
    newspr->angle      = angle;
    newspr->trans      = type;
    newspr->transColor = tc;
    newspr->q.priority = depth;
#ifdef MULTI_LIST
    QAdd(&aDisplayList[0], &newspr->q, sprFlags & SPR_FLAG_ADD_REVERSE);
    newspr->parent     = &aDisplayList[0];
#else
    QAdd(&displayList, &newspr->q, sprFlags & SPR_FLAG_ADD_REVERSE);
    newspr->parent     = &displayList;
#endif
    newspr->rendererPtr = aRendererInfo[type & 0xFF].ptr;

    if (aRendererInfo[type & 0xFF].ptr == 0) {
      printf("\nLIBSPRITE ERROR:  Unimplemented sprite renderer #%d\n", type & 0xFF);
    }

    return (newspr);    
  }

  return(0);
}

/*
    Modifies a sprite parameters
*/


int SPRModifySprite(SPRITE * sprite, int x, int y, int angle, int xscale, int yscale,
		    int type, int tc, int depth)
{
  if (sprite->q.priority != depth) {
    QRemove(sprite->parent, &sprite->q);
  }

  sprite->x=x;
  sprite->y=y;
  sprite->xscale=xscale;
  sprite->yscale=yscale;
  sprite->angle=angle;
  sprite->trans=type;
  sprite->transColor=tc;

  if (sprite->q.priority != depth) {
    sprite->q.priority = depth;
#ifdef MULTI_LIST
    if (sprite->parent == &aDisplayList[0]) {
      QAdd(sprite->parent, &sprite->q, sprFlags & SPR_FLAG_ADD_REVERSE);
    } else {
      QAdd(sprite->parent, &sprite->q, -1);
    }
#else
    if (sprite->parent == &displayList) {
      QAdd(sprite->parent, &sprite->q, sprFlags & SPR_FLAG_ADD_REVERSE);
    } else {
      QAdd(sprite->parent, &sprite->q, -1);
    }
#endif
  }
  return 0;
}

/*
    Removes a sprite from display list
*/

int SPRRemoveSprite(SPRITE *sprite)
{
#ifdef MULTI_LIST
  if (sprite->parent != &aDisplayList[0]) {
    return -1;
  }
  QRemove(&aDisplayList[0], &sprite->q);
#else
  if (sprite->parent != &displayList) {
    return -1;
  }
  QRemove(&displayList, &sprite->q);
#endif
  
  QAdd(&usedSprites, &sprite->q, -1);
  sprite->parent = &usedSprites;

  return 0;
}

/*
    Deletes the sprite definition
*/

int SPRDeleteSprite( SPRITE *sprite )
{
    if ( sprite->parent == &freeSprites )
    {
      return 0;
    }

    QRemove( &usedSprites, &sprite->q );
    QAdd( &freeSprites, &sprite->q, -1 );
    sprite->parent = &freeSprites;
    
    return 0;
}

//
// Combination of previous two routines
//

int SPRRemoveAndDeleteSprite(SPRITE *sprite)
{
#ifdef MULTI_LIST
  if (sprite->parent != &aDisplayList[0]) {
    return -1;
  }

  QRemove(&aDisplayList[0], &sprite->q);
#else
  if (sprite->parent != &displayList) {
    return -1;
  }

  QRemove(&displayList, &sprite->q);
#endif
  QAdd(&freeSprites, &sprite->q, -1);
  sprite->parent = &freeSprites;
  
  return 0;
}

/*
    Quick simple parameter modifiers
*/


void SPRSetSpriteSource(SPRITE * sprite, int x, int y, int w, int h)
{
    sprite->src_x = x << 16;
    sprite->src_y = y << 16;
    sprite->w = w;
    sprite->h = h;
}

void SPRSetImageInfo( SPRITE *sprite, SPR_IMAGE_INFO *info )
{
  sprite->source = info->img;
  sprite->dmaflags = info->dmaflags;
}
 
void SPRSetSpriteXY( SPRITE *sprite, int x, int y )
{
  if ( sprite->rendererPtr == aRendererInfo[kSpriteSimpleTp].ptr )
  {
    sSpriteSimple *sp = (sSpriteSimple*) sprite;
    sp->aSprCoord[0].x = x + offsetX;
    sp->aSprCoord[0].y = y + offsetY;
  }
  else
  {
    sprite->x = x + offsetX;
    sprite->y = y + offsetY;
  }
}

void SPRSetSpriteScale(SPRITE * sprite, int xscale, int yscale)
{
    sprite->xscale = xscale;
    sprite->yscale = yscale;
}

void SPRSetSpriteRotation(SPRITE * sprite, int angle)
{
  sprite->angle = angle;
}

void SPRSetSpriteType(SPRITE * sprite, int type)
{
    sprite->trans = type;
}

void SPRSetSpriteTColor(SPRITE * sprite, int tc)
{
    sprite->transColor = tc;
}

void SPRSetSpriteDepth(SPRITE * sprite, int depth)
{
    QRemove(sprite->parent, &sprite->q);
    sprite->q.priority = depth;
#ifdef MULTI_LIST
    if (sprite->parent == &aDisplayList[0]) {
      QAdd(sprite->parent, &sprite->q, sprFlags & SPR_FLAG_ADD_REVERSE);
    } else {
      QAdd(sprite->parent, &sprite->q, -1);
    }
#else
    if (sprite->parent == &displayList) {
      QAdd(sprite->parent, &sprite->q, sprFlags & SPR_FLAG_ADD_REVERSE);
    } else {
      QAdd(sprite->parent, &sprite->q, -1);
    }
#endif
}


/*
    Main drawing function
    
    Walks down the display list and feed the available MPEs to render the sprites
    
    Commbus command for the renderes:
    
    p[0]:  Pointer to RASTER_INFO structure (destination info and clip region)
    p[1]:  Pointer to SPRITE
//    p[2]:  Bit 16-31: Slice height, Bit 0: One-Shot (draw only one sprite)
    p[2]:  Bit 24-31: Slice height, Bit 16-23: Logical MPE number, Bit 8-15: Total MPE number, 
           Bit 0: One-Shot (draw only one sprite)
//    p[3]:  Bit 16-31: Logical MPE number, Bit 0-15: Total MPE number 
    p[3]:  Clear color
*/



void SPRDraw(int clrScreen, int wait, int displayListIndex)
{

  int m,sr,i;
  int hints = 0;
  PriorityQueue *thisDisplayList;
  int sprUsed;

  //    if (!displayList.list) return;

  // Keep track of the maximum number of sprites used
  sprUsed = MAX_SPRITES - countElements( &freeSprites );
  if ( sprUsed > maxSpritesUsed )
  {
    maxSpritesUsed = sprUsed;
    //    printf( "New max sprites used: %d\n", maxSpritesUsed );
  }

  // Wait until the renderers are finished
  while (MPEMask != idleMask);
    
/*      
    if (sprFlags & SPR_FLAG_DOUBLE_BUFFER) {
      memcpy(spriteBlock[1], spriteBlock[0], sizeof(SPRITE) * MAX_SPRITES);
      //    printf("\n START: %08X %08X ", spriteBlock[0], spriteBlock[1]);
      for (i = 0; i < MAX_SPRITES; i++) {
	if (spriteBlock[1][i].q.next)
	  spriteBlock[1][i].q.next =
	    (PriorityQueueMember*) ((long) spriteBlock[1][i].q.next + sizeof(SPRITE) * MAX_SPRITES);
	//      printf("\n %08X %08X ", spriteBlock[0][i].q.next.index, spriteBlock[1][i].q.next.index);
      }
    }
*/

  _DCacheSync();

#ifdef MULTI_LIST
  if (!checkAndAllocateDisplayList(displayListIndex))
  {
    return;
  }
  thisDisplayList = &aDisplayList[displayListIndex];
#else
  thisDisplayList = &displayList;
#endif
    
  if ( clrScreen & 1 )
  {
    /*
        SPRFill(rinfo.clip_min_x,rinfo.clip_min_y,
            rinfo.clip_max_x-rinfo.clip_min_x+1,
            rinfo.clip_max_y-rinfo.clip_min_y+1,rinfo.bgColor);
    */
    if (sprFlags & SPR_FLAG_CLEAR_FAST)
    {
      hints |= 1<<2;
    }
    else
    {
      SPRFill( rinfo.clip_min_x, rinfo.clip_min_y,
	       rinfo.clip_max_x - rinfo.clip_min_x + 1,
	       rinfo.clip_max_y - rinfo.clip_min_y + 1,
	       rinfo.clrParam1 );
    }
    
  }

  if ( clrScreen & ~0x1 )
  {
    hints |= 1<<3;
  }

  /*
  if (!thisDisplayList->list) {
    return;
  }
  */

  DISABLE_INTERRUPTS(sr);
  MPEMask = 0x0;
  RESTORE_INTERRUPTS(sr);
    
  //  for (m = startMPE, i = 0; m <= endMPE; m++, i++) {
  for( m = 0, i = 0; m < 32; m++ )
  {
    if ( usedMPEs & ( 1 << m ) )
    {
      if ( sprFlags & SPR_FLAG_DOUBLE_BUFFER )
      {
	_CommSendDirect( (long) &rinfo, (long) thisDisplayList->list,
			 ( sliceH << 20 ) | ( i << 16 ) | ( numMPEs << 8 ) | hints,
			 0, m, 0 );
      }
      else
      {
	_CommSendDirect( (long) &rinfo, (long) thisDisplayList->list,
			 ( sliceH << 20 ) | ( i << 16 ) | ( numMPEs << 8 ) | hints,
			 0, m, 0);
      }

      i++;
    }
  }

  // Swap sprite buffers
  //    sprIndexWork = 1 - sprIndexWork;

  /* Wait for them to finish */
  if ( wait )
  {
    while ( MPEMask != idleMask );
  }
    
  autoDisplayListIndex = 1 - autoDisplayListIndex;
}

void drawString(char *string, int *x, int *y)
{
  DebugWS(rinfo.dmaflags,  rinfo.dest,  *x+1, *y+1, 0x10808000, string);
  DebugWS(rinfo2.dmaflags, rinfo2.dest, *x+1, *y+1, 0x10808000, string);
  DebugWS(rinfo3.dmaflags, rinfo3.dest, *x+1, *y+1, 0x10808000, string);
  DebugWS(rinfo.dmaflags,  rinfo.dest,  *x,   *y,   0xEB808000, string);
  DebugWS(rinfo2.dmaflags, rinfo2.dest, *x,   *y,   0xEB808000, string);
  DebugWS(rinfo3.dmaflags, rinfo3.dest, *x,   *y,   0xEB808000, string);
  *y += 20;
}

int SPRWait(void)
{
  int i;
  int cnt = 0;
  char buf[80];
  int data[16];
  int mpeNum;
  int yStart = 10;
  int x, y;
  int addr;
  int *scratch;
  int drawn = 0;
  int pageDelay = 0;
  int pageNum = 0;

  static int gotBiosInfo = 0;
  static struct BiosInfo *bi;

  if (!gotBiosInfo) {
    bi = _BiosGetInfo();
    gotBiosInfo = 1;
  }

  while (MPEMask != idleMask) {
    cnt++;

    //    if (((_Controller[1].buttons & JOY_NUON) && !strcmp(bi->date_string, "Sep 19 2001")) ||
    //	(cnt > 2000000)) {
    if (cnt > 2000000) {
      
      if (!drawn) {

	drawn = 1;

	for ( x = rinfo.clip_min_x; x < rinfo.clip_max_x; x += 8 )
	{
	  for ( y = rinfo.clip_min_y; y < rinfo.clip_max_y; y += 8 )
	  {
	    _raw_plotpixel( rinfo.dmaflags,  (void*) rinfo.dest,  (8 << 16 ) | x, ( 8 << 16 ) | y, 0x137E8E00 );
	    _raw_plotpixel( rinfo2.dmaflags, (void*) rinfo2.dest, (8 << 16 ) | x, ( 8 << 16 ) | y, 0x137E8E00 );
	    _raw_plotpixel( rinfo3.dmaflags, (void*) rinfo3.dest, (8 << 16 ) | x, ( 8 << 16 ) | y, 0x137E8E00 );
	  }
	}
    
	if (!(MPEMask & 0x1) && (idleMask & 0x1)) mpeNum = 0;
	else if (!(MPEMask & 0x2) && (idleMask & 0x2)) mpeNum = 1;
	else if (!(MPEMask & 0x4) && (idleMask & 0x4)) mpeNum = 2;
	else mpeNum = -1;

	x = 8;
	y = yStart;
	
	if (mpeNum == -1) {
	  sprintf(buf, "hung %ld %ld", MPEMask, idleMask);
	  drawString(buf, &x, &y);
	} else {

	  switch (pageNum) {
	    case 0:
	      sprintf(buf, "mpe %d crashed", mpeNum);
	      drawString(buf, &x, &y);
	
	      data[0] = _MPEReadRegister(mpeNum, (void *) 0x20500070);  // pcexec
	      data[1] = _MPEReadRegister(mpeNum, (void *) 0x20500060);  // pcroute
	      data[2] = _MPEReadRegister(mpeNum, (void *) 0x20500050);  // pcfetch
	      sprintf(buf, "%08X %08X %08X", data[0], data[1], data[2]);
	      drawString(buf, &x, &y);
	      
	      data[0] = _MPEReadRegister(mpeNum, (void *) 0x20500010);  // excepsrc
	      sprintf(buf, "excepsrc=%08X", data[0]);
	      drawString(buf, &x, &y);
	  
	      addr = (int) &object;
	      addr += 0x800000 * mpeNum;
	      sprintf(buf, "sprite data %08X:", addr);
	      drawString(buf, &x, &y);
	      scratch = _MemLocalScratch(0);
	      _DMALinear((1<<13) | (12<<16), (void *) addr, (void *) scratch);
	      sprintf(buf, "%08X %08X %08X %08X", scratch[0], scratch[1], scratch[2], scratch[3]);
	      drawString(buf, &x, &y);
	      sprintf(buf, "%08X %08X %08X %08X", scratch[4], scratch[5], scratch[6], scratch[7]);
	      drawString(buf, &x, &y);
	      sprintf(buf, "%08X %08X %08X %08X", scratch[8], scratch[9], scratch[10], scratch[11]);
	      drawString(buf, &x, &y);
	
	      addr = (int) &mpeinfo;
	      addr += 0x800000 * mpeNum;
	      _DMALinear((1<<13) | (1<<16), (void *) addr, (void *) scratch);
	      sprintf(buf, "mpeinfo=%08X", scratch[0]);
	      drawString(buf, &x, &y);
	      
	      data[0] = _MPEReadRegister(mpeNum, (void *) 0x20500250);  // ru
	      data[1] = _MPEReadRegister(mpeNum, (void *) 0x20500260);  // rv
	      data[2] = _MPEReadRegister(mpeNum, (void *) 0x20500280);  // uvbase
	      sprintf(buf, "u=%08X v=%08X base=%08X", data[0], data[1], data[2]);
	      drawString(buf, &x, &y);
	      
	      data[0] = _MPEReadRegister(mpeNum, (void *) 0x20500200);  // rx
	      data[1] = _MPEReadRegister(mpeNum, (void *) 0x20500210);  // ry
	      data[2] = _MPEReadRegister(mpeNum, (void *) 0x20500230);  // xybase
	      sprintf(buf, "x=%08X y=%08X base=%08X", data[0], data[1], data[2]);
	      drawString(buf, &x, &y);
	      break;
	
	    case 1:
	      sprintf(buf, "mpe %d crashed", mpeNum);
	      drawString(buf, &x, &y);
	
	      sprintf(buf, "registers:");
	      drawString(buf, &x, &y);

	      for (i = 0; i < 8; i++) {
		data[0] = _MPEReadRegister(mpeNum, (void *) (0x20500300 + (0x40 * i)));  // v[0]
		data[1] = _MPEReadRegister(mpeNum, (void *) (0x20500310 + (0x40 * i)));  // v[1]
		data[2] = _MPEReadRegister(mpeNum, (void *) (0x20500320 + (0x40 * i)));  // v[2]
		data[3] = _MPEReadRegister(mpeNum, (void *) (0x20500330 + (0x40 * i)));  // v[3]
		sprintf(buf, "%08X %08X %08X %08X", data[0], data[1], data[2], data[3]);
		drawString(buf, &x, &y);
	      }
	      break;
	  }
	}
	
      } else {
	pageDelay++;

	if (pageDelay > 5000000){
	  pageDelay = 0;
	  pageNum++;
	  if (pageNum > 1) pageNum = 0;
	  drawn = 0;
	}
      }
    }
  }

  return(cnt);
}


/*
   Low-Level blitter call
*/

SPRITE srcinfo;
RASTER_INFO destinfo;

int SPRBlitter(char *src, long src_dmaflags, int src_x, int src_y, int src_w, int src_h,
                char *dest, long dest_dmaflags, int dest_x, int dest_y,
                int scalex, int scaley, int angle,
                int clip_min_x,int clip_min_y,int clip_max_x,int clip_max_y,
                int type, int transColor)
{
  int sr,m,i;
	
  srcinfo.q.next=0;
  srcinfo.src_x = src_x<<16;
  srcinfo.src_y = src_y<<16;
  srcinfo.x = dest_x;
  srcinfo.y = dest_y;
  srcinfo.xscale = scalex;
  srcinfo.yscale = scaley;
  srcinfo.w = src_w;
  srcinfo.h = src_h;
  srcinfo.source=src;
  srcinfo.dmaflags=src_dmaflags;
  srcinfo.trans=type;
  srcinfo.tint=0x10808000;
  srcinfo.transColor=transColor;
  srcinfo.rendererPtr = aRendererInfo[type & 0xFF].ptr;

  if (aRendererInfo[type & 0xFF].ptr == 0) {
    printf("\nLIBSPRITE ERROR:  Unimplemented sprite renderer #%d\n", type & 0xFF);
  }

  destinfo.dest=dest;
  destinfo.dmaflags=dest_dmaflags;
  destinfo.clip_min_x=clip_min_x;
  destinfo.clip_min_y=clip_min_y;
  destinfo.clip_max_x=clip_max_x;
  destinfo.clip_max_y=clip_max_y;

  _DCacheSync();
  DISABLE_INTERRUPTS(sr);
  MPEMask = 0x0;
  RESTORE_INTERRUPTS(sr);
  
  //  for (m=startMPE,i=0;m<=endMPE;m++,i++)
  for(m = 0, i = 0; m < 32; m++) {
    if (usedMPEs & (1<<m)) {
      _CommSendDirect((long)&destinfo, (long)&(srcinfo.q),
		      (sliceH<<20) | (i<<16) | (numMPEs<<8) | (1<<0),
		      0, m,0);
      i++;
    }
  }
  
  while (MPEMask != idleMask);
  return 0;
}


int SPRDebug(int mode, char *str)
{
  if (aRendererInfo[5].ptr != 0x122023B0) {
    printf("NO! (%s)\n", str);
  }

  return 0;
}

// =================================================================================================

void SPRSetClearMethod(int clrIndex, int param1, int param2, int param3)
{
  clrMethod = clrIndex;
  clrParam1 = param1;
  clrParam2 = param2;
  clrParam3 = param3;
}

// =================================================================================================

void SPRPrintAndClearDelay()
{
  printf("delay=%d ", delay);
  delay = 0;
}

// =================================================================================================

void SPRSetOffset(int x, int y)
{
  if (x != -1) offsetX = x;
  if (y != -1) offsetY = y;
}
