;; =================================================================================================

//	srce_x = r8
//	srce_y = r9
	srce_xsize = r10
	srce_ysize = r11
	srce_xcen = r16
	srce_ycen = r17

	dest_x1 = r18
	dest_y1 = r19
	dest_x2 = r20
	dest_y2 = r21
	dest_x3 = r22
	dest_y3 = r23
	dest_x4 = r28
	dest_y4 = r29

	dest_xsize = r20
	dest_ysize = r21
	dest_xtile = r22
	dest_ytile_r23 = r23

//	buffer_offset = r24
	bufOffset_r8	= r8
	srcx = r25
	srcy = r26
	flags_r15 = r15
	ang = r8
	dest_info = r9
	srcix = r18
	srciy = r19
	xscal = r22
	yscal = r23

	fromsource = v6		;Matrix that goes from source to dest space
	tosource = v7		;Matrix that goes from dest to source space

//	ranseed1 = r8
//	ranmask = r9
//	sprcount = r10

	pixel1 = v0
	pixel = v0
	pixel2 = v1
	pixel3 = v2
	pixel4 = v3
	pixel5 = v4
	xi = tosource[0]
	yi = tosource[2]
	x = r20
	_y = r21
	dma_dbase = r24
	mix = r25
	four = r26
	dest_r = r27
	bg_pixel = object+40
	trans = object+28

	.segment	spritec

draw_sprite:
	push	v0,rz

	;; Get this sprite's hint flags
	ld_s	spr_hint,r0
	nop
	
	;; Force a hang if the user wants to debug this sprite
`hang:
	btst	#SPR_HINT_DEBUG,r0
	bra	ne,`hang,nop

	;; Some objects can be immediately rendererd without all the usual rigamarole
	btst	#SPR_HINT_RENDER_IMM,r0		; check if we should jump straight to the renderer
	bra	eq,`noImmediateRender,nop
	jsr	mdma_finished,nop		; wait for renderer to finish loading
	jmp	pixgen,nop			; call the renderer
`noImmediateRender:
	
	mv_s	#object,dest_info
	mv_s	dest_info,r0		;point at object
	ld_v	(r0),v1			;get first vector of object
	add	#16,r0			;point to next vector
{	mv_s	r6,srce_xcen		;set sprite offset X
	copy	r7,srce_ycen		;sprite offset Y
}
{	mv_s	r5,srce_ysize		;extract source x- and y-size 
	lsr	#16,r5,srce_xsize
}
{	ld_v	(r0),v5			;get angle and scales...
	bits	#15,>>#0,srce_ysize
}

	;; set up the matrix that goes from source to dest
	jsr	sincos			;get the trig
	copy	r22,r0			;!sincos needs flags set!
	mv_s	r22,ang			;save the angle
	
{	mv_s	r0,fromsource[0]	;set cos
	sub	r1,#0,fromsource[1]	;set -sin
}
{	mv_s	r1,fromsource[2]	;set sin
	copy	r0,fromsource[3]	;set cos
}
	mv_v	fromsource,tosource
	mul	r20,fromsource[0],>>#24,fromsource[0]	;scale, make it 16:16 (used in rot8)
	mul	r21,fromsource[1],>>#24,fromsource[1]	;scale, make it 16:16
	mul	r20,fromsource[2],>>#24,fromsource[2]	;scale, make it 16:16
	mul	r21,fromsource[3],>>#24,fromsource[3]	;scale, make it 16:16

; I need the recips of the scales for the dest tile size calculation
/*
	cmp	#$00010000,r20		; skip recip if scale is 1.0
{	bra	eq,nrsign1
	mv_s	#$01000000,r12
}
*/
	jsr	recip			;get 1/xscale
	mv_s	r20,r0
{	abs	r0
	mv_s	#16,r1			;#fracbitz
}
	sub	#24,r1
	rot	r1,r0,r2		; get the bit to round...
	bits	#0,>>#31,r2		; ...
	btst	#31,r20			;to restore sign
	bra	eq,nrsign1
	ls	r1,r0,r12		;1/xscale in r12
	add	r2,r12			; round up if last bit shifted out was 1
	neg	r12
nrsign1:
/*
	cmp	#$00010000,r21		; skip recip if scale is 1.0
{	bra	eq,nrsign2
	mv_s	#$01000000,r13
}
*/
	jsr	recip					
	mv_s	r21,r0
{	abs	r0
	mv_s	#16,r1			;#fracbitz
}
	sub	#24,r1
	rot	r1,r0,r2		; get the bit to round...
	bits	#0,>>#31,r2		; ...
	btst	#31,r21			;to restore sign
	bra	eq,nrsign2
	ls	r1,r0,r13		;1/yscale in r13
	add	r2,r13			; round up if last bit shifted out was 1
	neg	r13
nrsign2:

; save the recips for retrieval later on

	push	v3

; now make yscale/xscale in r12, xscale/yscale in r13

	mul	r21,r12,>>#24,r12	; r12 = yscale/xscale
	mul	r20,r13,>>#24,r13	; r13 = xscale/yscale
	mv_s	r12,r14			;save 4 signs
	copy	r13,r15
	abs	r12
	mv_s	#$10000,r0		;These can never be greater than 1.0.
	cmp	r0,r12
	bra	le,ox1
	abs	r13
	mv_s	r20,xscal		;get xscale to a temp store
	mv_s	r0,r12
ox1:

	cmp	r0,r13
	bra	le,ox2
	mv_s	r21,yscal		;get yscale out
	btst	#31,r14
	mv_s	r0,r13
ox2:

; restore signs

	bra	eq,nneg11
	btst	#31,r15
	mv_s	#0,r0
	subm	r12,r0,r12
nneg11:

	bra	eq,nneg22
	abs	tosource[0]
	abs	tosource[1]	
	neg	r13
nneg22:

; okay, got that matrix.  Now calculate the optimum dest tile size

; do some calculations for the optimum tile size

	jsr	recip
	add	tosource[1],tosource[0],r0	;(sin x plus cos x)
	mv_s	#30,r1				;@ 30 bits of prec
	sub	#16,r1
	ls	r1,r0,r1			;get (1/sin+cos) in r1 in 16.16
	mv_s	#tilesize,r0			;Size of active bit of tile cache
	mul	tosource[1],r0,>>#14,r0		;tile size * sin of the angle @ 16:16
	mv_s	#(-tilesize<<15),r4		;half tilesize
	mul	r0,r1,>>#16,r1			;r1 now has (L sin x/(sin x+cos x)) where L=active cache size.
	mv_s	#(tilesize<<16),r2
	abs	r1
	sub	r0,r0
	sub	r1,r2				;r1 has "a", r2 has "b"
	copy	r0,r3				;half length
	add	r4,r0
	add	r4,r1				;r0,r1 = (0,a) centered
	add	r4,r2
	add	r4,r3				;r2,r3 = (b,0) centered
	jsr	sincos				;get the trig
	push	v0				;save for doing y
	copy	ang,r0
	abs	r0
	abs	r1

{	mv_s	r0,tosource[0]			;set cos
	sub	r1,#0,tosource[1]		;set -sin
}
{	mv_s	r1,tosource[2]			;set sin
	copy	r0,tosource[3]			;set cos
}
 	pop	v0
	nop
	mul	r12,r0,>>#16,r0
 	mul	r12,r2,>>#16,r2
	mul	r13,r1,>>#16,r1
 	mul	r13,r3,>>#16,r3				;Correct for scaling differential
	copy	xscal,r12
	copy	yscal,r13
	abs	r12
	abs	r13
	mul	r12,tosource[0],>>#30,tosource[0]	;make it 16:16
	mul	r13,tosource[1],>>#30,tosource[1]	;make it 16:16
	mul	tosource[0],r0,>>#16,r0
	mul	tosource[1],r1,>>#16,r1
	mul	tosource[0],r2,>>#16,r2
	mul	tosource[1],r3,>>#16,r3
	add	r1,r0					;final x
	add	r3,r2					;final x2
	sub	r0,r2					;should be optimal x-length
	abs	r2
	lsr	#16,r2,dest_xtile			;save final x size

	bra	eq,trivialReject2			; if tile is zero, skip
	
;	add	#1,dest_xtile
	add	#1,srce_xsize
	add	#1,srce_ysize

	cmp	#dmasize,dest_xtile			;limit tile size to dma size
	bra	le,baabaa
{	mv_s	srce_xsize,r0
	lsl	#1,srce_xsize
}
{	lsl	#1,srce_ysize
	mv_s	srce_ysize,r1
}
;	lsr	#1,srce_xsize,r0
;	lsr	#1,srce_ysize,r1
	mv_s	#dmasize,dest_xtile
baabaa:

	copy	dest_xtile,dest_ytile_r23
	st_s	#6,acshift
	push	v5						;save dest_xtile,dest_ytile


; Translate corner points into destination space

;	lsr	#1,srce_xsize,r0
;	lsr	#1,srce_ysize,r1

	jsr	rot8
	neg	r0
	neg	r1
	
	jsr	rot8
	mv_s	r4,dest_x1
{	mv_s	r2,dest_y1
	add	srce_xsize,r0
}

	jsr	rot8
{	mv_s	r4,dest_x2
	sub	srce_xsize,r0
}
{	mv_s	r2,dest_y2
	add	srce_ysize,r1
}

	jsr	rot8
	mv_s	r4,dest_x3
{	mv_s	r2,dest_y3
	add	srce_xsize,r0
}

	mv_s	r4,dest_x4
	mv_s	r2,dest_y4
	st_s	#0,acshift

; sort points into box order

	lsr	#1,srce_xsize
	lsr	#1,srce_ysize
	sub	#1,srce_xsize
	sub	#1,srce_ysize

	;; Moved the 1-4 comparison above 1-2 so 270 degree rotations work
	cmp	dest_y1,dest_y4
	jmp	ge,srt3,nop
{
	mv_s	dest_y4,dest_y1
	copy	dest_y1,dest_y4
}
{
	mv_s	dest_x4,dest_x1
	copy	dest_x1,dest_x4
}
srt3:
	cmp	dest_y1,dest_y2
	jmp	ge,srt1,nop
{
	mv_s	dest_y2,dest_y1
	copy	dest_y1,dest_y2
}
{
	mv_s	dest_x2,dest_x1
	copy	dest_x1,dest_x2
}
srt1:
	cmp	dest_y1,dest_y3
	jmp	ge,srt2,nop
{
	mv_s	dest_y3,dest_y1
	copy	dest_y1,dest_y3
}
{
	mv_s	dest_x3,dest_x1
	copy	dest_x1,dest_x3
}
srt2:

; get dest_y2 and dest_x2 to be the next highest

	cmp	dest_y2,dest_y3
	jmp	ge,srt4,nop
{
	mv_s	dest_y3,dest_y2
	copy	dest_y2,dest_y3
}
{
	mv_s	dest_x3,dest_x2
	copy	dest_x2,dest_x3
}
srt4:
	cmp	dest_y2,dest_y4
	jmp	ge,srt5,nop
{
	mv_s	dest_y4,dest_y2
	copy	dest_y2,dest_y4
}
{
	mv_s	dest_x4,dest_x2
	copy	dest_x2,dest_x4
}
srt5:

; finally put dest_y3 and dest_y4 in order

	cmp	dest_y3,dest_y4
	jmp	ge,srt6,nop
{
	mv_s	dest_y4,dest_y3
	copy	dest_y3,dest_y4
}
{
	mv_s	dest_x4,dest_x3
// ---Not used---
//	copy	dest_x3,dest_x4
}
srt6:

; now get position and extent of total bounding box

	mv_s	dest_y1,dma_ypos	;this is top
	sub	dest_y1,dest_y4,r3	;this is vertical size
	ld_v	dest_screen,v7		;get clip box info (do it here to avoid a nop later on)
	sub	dest_x2,dest_x3,r2	;this is horizontal size
	bra	ge,gibbon1		;if greater then dest_x2 is left edge
	mv_s	dest_x2,dma_xpos	;copy assuming left edge
	ld_s	(dest_info),r20		;get dest x and ypos in r20 (do it here to avoid a nop)
	copy	dest_x3,dma_xpos	;this if x2 not left edge

gibbon1:

; got b-box pos in (dma_xpos,dma_ypos), size in (r2,r3).
; now clip the position and size against the viewport


	abs	r2			; x abs, from previous stuff	

{	mv_s	r30,r28
	lsr	#16,r30,r29		;extract clip params
}
{	mv_s	r31,r30
	lsr	#16,r31
}
{	mv_s	r20,r21
	lsl	#16,r28
}
	lsl	#16,r30
	lsl	#16,r21
	lsl	#16,r29
	lsl	#16,r31

	and	#$FFFF0000,r20
	and	#$FFFF0000,dma_ypos
	and	#$FFFF0000,dma_xpos

	add	dma_xpos,r20,r0
	add	dma_ypos,r21,r1		;moved to dest position

	cmp	r29,r0			;check against LH edge of viewport
	jmp	ge,trivialReject	;trivial reject
	cmp	r31,r1			;check against high Y of viewport
	jmp	ge,trivialReject	;trivial reject
	add	r0,r2,r22		;position of RH edge
	cmp	r28,r22
	jmp	le,trivialReject	;reject if -ve
	add	r1,r3,r23		;position of high Y edge
	cmp	r30,r23
	jmp	le,trivialReject	;reject if -ve

; okay, it is somewhere on screen

	sub	r28,r0			;clip to left edge
	jmp	ge,xclip_1,nop		;not needed if +ve
	add	r0,r2			;update width
	sub	r0,dma_xpos		;and position
xclip_1:
	sub	r30,r1			;clip to low y
	jmp	ge,yclip_1,nop
	add	r1,r3
	sub	r1,dma_ypos
yclip_1:
	sub	r29,r22			;check RH edge
	jmp	le,xclip_2,nop
	sub	r22,r2			;dec width
xclip_2:
	sub	r31,r23			;check hi Y edge
	jmp	le,yclip_2,nop
	sub	r23,r3
yclip_2:

	pop	v5
	nop
	lsr	#16,r2,dest_xsize
	lsr	#16,r3,dest_ysize

	add	#1,dest_xsize
	add	#1,dest_ysize

; finish making tosource matrix (add in scales)

	jsr	sincos			;get the trig
	mv_s	ang,r0
	neg	r0
{	mv_s	r0,tosource[0]		;set cos
	sub	r1,#0,tosource[1]	;set -sin
}
{	mv_s	r1,tosource[2]		;set sin
	copy	r0,tosource[3]		;set cos
}

; do some calculations for the optimum tile size
	pop	v0					;get back the recips we made earlier on
	copy	dest_xtile,srcix
	copy	dest_ytile_r23,srciy			;prepare to make increment-per-tile
	mul	r0,tosource[0],>>#30,tosource[0]	;make it 16:16
	mul	r0,tosource[1],>>#30,tosource[1]	;make it 16:16
	mul	r1,tosource[2],>>#30,tosource[2]	;make it 16:16
	mul	r1,tosource[3],>>#30,tosource[3]	;make it 16:16
	mul	tosource[0],srcix,>>#8,srcix
	mul	tosource[2],srciy,>>#8,srciy		;make it
	mv_s	dma_xpos,r0
	mv_s	dma_ypos,r1				;current top corner

	copy	r0,r2
	copy	r1,r3
	mul	tosource[0],r0,>>#24,r0
	mul	tosource[1],r1,>>#24,r1
	mul	tosource[2],r2,>>#24,r2
	mul	tosource[3],r3,>>#24,r3
	add	r0,r1,srcx
	add	r2,r3,srcy				;make co-ords in source space

	asr	#8,tosource[0]
	asr	#8,tosource[1]
	asr	#8,tosource[2]
	asr	#8,tosource[3]

	bra	dosprite,nop
spriteDoneInner:
	pop	v0,rz
	nop
	bra	spriteDoneOuter,nop

rot8:
	mul	r0,fromsource[0],>>acshift,r4
	mul	r1,fromsource[1],>>acshift,r5
	mul	r0,fromsource[2],>>acshift,r2
{	mul	r1,fromsource[3],>>acshift,r3
	add	r5,r4
}
{	mv_s	#1,r5
	btst	#31,r4
}
{	abs	r4
	bra	eq,done1
	addm	r3,r2
}
{	ls	r5,r4
	mv_s	#0,r3
}
{	addm	r5,r4
	btst	#31,r2
}
	subm	r4,r3,r4
done1:
{	abs	r2
	rts	eq
}
{	ls	r5,r2
	rts
}
	addm	r5,r2
	neg	r2

mpe_num = r4				;Stuff for multi-MPE slicing up.
slice_size = r5
total_mpes = r6
slice_count = r7
y__lo = r0
y__hi = r1
chunk_size = r2
slice_offset = r3

dosprite:
.if (PERFMON_ENABLE == 1)
	ld_s	perfmonSprites,r0
	nop
	add	#1,r0
	st_s	r0,perfmonSprites
.endif

.if (0)
	mv_s	#1,r0
`loop:
	cmp	#1,r0
	jmp	eq,`loop,nop
.endif
	
	mv_s	#((1<<28)|(4<<20)|(cachesize<<0)),r0	; source ?
	st_s	r0,uvctl
	st_s	r0,xyctl
	st_s	#((1<<28)|(4<<20)),linpixctl		; dest ?
	
	;; Set up the translucency values for Yaroze-type sprites
	ld_s	spr_trans,r0
	nop
	and	#$FFFF0000,r0,r1
	asr	#6,r1				; background in 8.24
	lsl	#16,r0				; foreground in 8.24...
	asr	#6,r0				; ...with sign intact
	st_s	r0,sprTransFG
	st_s	r1,sprTransBG

	;; Now get foreground translucency, clamping to [0, 1) and reversing the sense (for alpha)
	st_s	#(1<<24),sprTransFGPix
	sat	#25,r0				; saturate in case positive value is too large
	bra	mi,GotFG,nop			; if value is negative then it's fully translucent
	neg	r0				; reverse sense (alpha of 0 means opaque)
	add	#(1<<24),r0
	st_s	r0,sprTransFGPix
GotFG:
	
	ld_s	spr_hint,r0
	nop
	ftst	#(1<<SPR_HINT_MATPREP_ONE)|(1<<SPR_HINT_MATPREP_BOTH),r0
	jsr	ne,matPrep,nop

	st_s	#doneTile,drawTileReturn	; initialize addr to return after drawing a tile
	
	mv_s	#0,r3
	ld_s	srcBuffLoad,r0			; Clear DMA_LEN for each buffer to init double buff
	ld_s	srcBuffDraw,r1
	add	#SRC_OFFSET_DMA_LEN,r0,r2
	st_s	r3,(r2)
	add	#SRC_OFFSET_DMA_LEN,r1,r2
	st_s	r3,(r2)
	
	asr	#16,dma_xpos			; no reason to keep these as 16.16
	asr	#16,dma_ypos

;	push	v0,rz
;	mv_s	#((1<<28)|(4<<20)|(cachesize<<0)),r0			; source ?
;	mv_s	#((4<<20)|(cachesize<<0)),r0			; source ?
;	st_s	r0,uvctl
;	st_s	r0,xyctl
;	st_s	#$10400000,linpixctl		; dest ?

{	jsr	mdma_finished,nop
	DMAWAITCNT_ITEM 1
	sub	bufOffset_r8,bufOffset_r8	;init double buffer offset to 0
}

; Traverse the dest rectangle by (dest_xtile,dest_ytile) sized blocks
xloop0:
	mv_s	#0,flags_r15
	st_v	v5,_mystack		;save xsize, ysize, xtile and ytile
	st_v	v3,_mystack+16		;save dma_xpos, dma_ypos, dma_len
	st_v	v6,_mystack+32		;save srcx,srcy

yloop0:
	sub	dest_ytile_r23,dest_ysize	;step over x size
	mv_s	dest_xtile,r0
	st_v	v5,_mystack2
	bra	ge,yl0			;skip if size doesn't go -ve
{	st_v	v3,_mystack2+16
	copy	dest_ytile_r23,r2	;need this unmolested in load_sourcetile or else!
}
	st_v	v6,_mystack2+32
	add	dest_ysize,dest_ytile_r23	;shorten the size for last horizontal tile
yl0:

	bra	load_sourcetile,nop
doneLoadSrcTile:
	jmp	lt,notile,nop		;returns -ve if tile is right off source

.if (PERFMON_ENABLE == 1)
	ld_s	perfmonTilesDrawn,r0
	nop
	add	#1,r0
	st_s	r0,perfmonTilesDrawn
.endif

	;; Don't want to use a jsr, so just branch there and back
	bra	drawTile,nop
doneTile:	
	ld_v	_mystack2+16,v3
	nop
	bset	#FLAGS_NEW_COLUMN,flags_r15
	st_v	v3,_mystack2+16

notile:
	ld_v	_mystack2+32,v6
	ld_v	_mystack2+16,v3
	ld_v	_mystack2,v5

	copy	tosource[1],r0
	copy	tosource[3],r1

	mul	dest_xtile,r0,>>#0,r0
	mul	dest_ytile_r23,r1,>>#0,r1
	add	r0,srcx
	add	r1,srcy	

	add	dest_ytile_r23,dma_ypos
	cmp	#0,dest_ysize
	jmp	gt,yloop0,nop

	ld_v	_mystack+32,v6
	ld_v	_mystack+16,v3
	ld_v	_mystack,v5

flork:
	add	srcix,srcx
	add	srciy,srcy
	sub	dest_xtile,dest_xsize
	jmp	gt,xloop0
	add	dest_xtile,dma_xpos
	nop

	;; Signify this is the last tile
	st_s	#doneLastTile,drawTileReturn	; return here when done with last tile
	bra	drawTile,nop
doneLastTile:
	bra	spriteDoneInner,nop

trivialReject:			;escape from trivial reject - needs to pop x2 then return
	pop	v1
trivialReject2:
	pop	v0
	bra	spriteDoneInner,nop

;;; 
;;; Separated this inner loop out so we can make it use a different source buffer than
;;; the pre-loading stuff.
;;; 
drawTile:
.if (PERFMON_ENABLE == 1)
	ld_s	perfmonScanlines,r0
	nop
	add	dest_ytile_r23,r0
	st_s	r0,perfmonScanlines
.endif

	;; Wait for load_sourcetile to finish reading
{	jsr	mdma_finished,nop
	DMAWAITCNT_ITEM 3
}
	
	;; Enable advanced DMA mode
	st_s	#(1<<9)|(1<<8),mdmactl		; Write 1 to done_cnt_enable & done_cnt_disable
	
	ld_s	srcBuffDraw,r0
	nop
//	add	#SRC_OFFSET_DMA_LEN,r0,r1
//	ld_s	(r1),dma_len	; (r14)
	add	#SRC_OFFSET_DMA_XPOS,r0,r1
	ld_v	(r1),v3
	
	add	#(SRC_BUFF_INFO<<2),r0,r1
{	st_s	r1,uvbase
	cmp	#0,dma_len			; See if this is the first time through
}
{	st_s	r1,xybase
	bra	eq,skipTile,nop			; If first time, then do not draw the tile
}
	
	add	#SRC_OFFSET_FILL_RIGHT,r0,r1
{	ld_s	(r1),r28
	add	#SRC_OFFSET_FILL_LEFT,r0,r1
}
{	ld_s	(r1),r29
	add	#SRC_OFFSET_SRCX,r0,r1
}
{	ld_s	(r1),srcx	; (r25)
	add	#SRC_OFFSET_SRCY,r0,r1
}
{	ld_s	(r1),srcy	; (r26)
	add	#SRC_OFFSET_DEST_YTILE,r0,r1
}
{	ld_s	(r1),dest_ytile_r23	; (r23)
//	add	#SRC_OFFSET_DMA_XPOS,r0,r1
}
//	add	#SRC_OFFSET_DMA_XPOS,r0,r1
//	ld_v	(r1),v3
//{	ld_s	(r1),dma_xpos	; (r12)
//	add	#SRC_OFFSET_DMA_YPOS,r0,r1
//}
//{	ld_s	(r1),dma_ypos	; (r13)
//	add	#SRC_OFFSET_FLAGS,r0,r1
//}
//	ld_s	(r1),flags_r15

	;; Fill the source buffer with blank space if necessary
	cmp	#0,r28
{	jsr	gt,fill_from_right,nop
	ld_s	srcBuffDraw,r1
}
	cmp	#0,r29
{	jsr	gt,fill_from_left,nop
	ld_s	srcBuffDraw,r1
}
	
	ld_v	_mystack4,v7		; reload this since we clobbered r28 & r29
	ld_s	pixjump_loc,r1		; preload this
	st_s	srcx,ru
	st_s	srcy,rv

yloop1:
{	jmp	(r1)			; call selected sprite type
	push	v4
	add	#dest_buffer,bufOffset_r8,inpBufPtr_r16
}
{	st_s	dma_len,rc0		; number of pixels to draw
	eor	inp1dot24_r19,inp1dot24_r19
}
{	st_s	#(0<<16),rx
	or	#(1<<24),inp1dot24_r19
}
scanline_done:
	pop	v4
	
	sub	#1,dest_ytile_r23
{	bra	gt,yloop1
	ld_s	pixjump_loc,r1		; reload this in case the pixgen clobbered it
	add	tosource[1],srcx	; advance to next tile...
}
{	add	tosource[3],srcy	; ...continue advancing to next tile
	st_s	srcx,ru
}
{	add	#1,dma_ypos
	st_s	srcy,rv
}

skipTile:
	st_s	#(1<<9),mdmactl		; Write 1 to done_cnt_disable to go back to simple DMA mode
	
{	jsr	mdma_wait,nop
	DMAWAITCNT_ITEM 7
}
	st_s	#dmaCmd_fromSpr,mdmacptr
	
	ld_s	srcBuffLoad,r0		; Swap the source buffer pointers
	ld_s	srcBuffDraw,r1
	st_s	r0,srcBuffDraw
	st_s	r1,srcBuffLoad

	ld_s	drawTileReturn,r0	; get the address where to return
	nop	
	jmp	(r0),nop		; return
	
load_sourcetile:
; Grab up the current sourcetile
.if (PERFMON_ENABLE == 1)
	ld_s	perfmonTilesTotal,r1
	nop
	add	#1,r1
	st_s	r1,perfmonTilesTotal
.endif

	;; Get the source extents of the current tile, and load in the appropriate bit.
	;; First, find the position of the lowest pixel in the source.
	mv_s	srcx,r4
	mv_s	srcy,r5

{	mul	tosource[1],r0,>>#0,r0	
	add	srcix,srcx,r1
}
	add	srciy,srcy,r3

; and find lowest
{	mul	tosource[3],r2,>>#0,r2		;got tile step in r0/r2
	cmp	r1,r4
}
	jmp	le,xlo1,nop
	mv_s	r1,r4
xlo1:
	cmp	r3,r5
	jmp	le,ylo1,nop
	mv_s	r3,r5
ylo1:

{	add	r0,r1
	addm	r2,r3,r3			;next co-ords
}
	
; find lowest
	cmp	r1,r4
	jmp	le,xlo2
	add	r4,r0
	add	r5,r2				;last co-ordpair in r0/r2
	mv_s	r1,r4
xlo2:
	cmp	r3,r5
	jmp	le,ylo2,nop
	mv_s	r3,r5
ylo2:

; find lowest
	cmp	r0,r4
	jmp	le,xlo3,nop
	mv_s	r0,r4
xlo3:
	cmp	r2,r5
	jmp	le,ylo3,nop
	mv_s	r2,r5
ylo3:

	;; now (r4,r5) has co-ords of lowest source point to be cached, uncentered
	st_v	v7,_mystack4
	asr	#16,r4
	asr	#16,r5				;int them
	mv_s	r4,r6
	mv_s	r5,r7
	asr	#16,srce_xcen,r0
	asr	#16,srce_ycen,r1
	add	r0,r6
	add	r1,r7
	asr	#1,srce_xsize,r0
	asr	#1,srce_ysize,r1
	add	r0,r4
	add	r1,r5

	add	#cachesize,r4,r2
	jmp	le,cachefail
	add	#cachesize,r5,r3
	jmp	le,cachefail			;rejecting tiles that lie wholly outside of source
	cmp	srce_xsize,r4
	jmp	ge,cachefail
	cmp	srce_ysize,r5
	jmp	ge,cachefail,nop

; if we get here we need to load up the cache.
	ld_s	srcBuffLoad,r30
	nop
	add	#(SRC_BUFF_INFO<<2),r30
	sub	srce_xsize,r2		;check for RH edge
	bra	lt,nrhsclip
	mv_s	#0,r28
	mv_s	#cachesize,r31		;Y size (can get altered by hi/lo clip)
	mv_s	r2,r28			;set fill to BG from right after load
nrhsclip:
	cmp	#0,r4			;check for LH edge		
	bra	gt,nlhsclip
	mv_s	#0,r29
	copy	r29,r1			;will be flag for total fill
	copy	r4,r29
	abs	r29			;set fill to BG from left after load
	lsl	#2,r29,r2		;offset for load
	add	r2,r30			;add offset
	sub	r4,r4			;and make origin 0
nlhsclip:
	cmp	#0,r5			;check for lo edge
	bra	gt,nloclip
	sub	r1,r1
	nop
{	mv_s	r5,r0
	add	r5,r31			;dec total vert size also
}
{	mv_s	#1,r1			;flag total fill
	abs	r0
	subm	r5,r5,r5		;and zero this
}
	lsl	#(cachesize_log2+2),r0
	add	r0,r30			;offset
nloclip:
	sub	srce_ysize,r3		;check for hi edge
	jmp	lt,nhiclip,nop
{	mv_s	#1,r1
	sub	r3,r31			;dec total loadsize
}
nhiclip:
	cmp	#0,r1
	jmp	eq,nofill,nop

	push	v1
	push	v7
{	jsr	fill,nop
	ld_s	srcBuffLoad,r1
}
	pop	v7
	pop	v1
	nop
	
nofill:
{	jsr	mdma_wait,nop
	DMAWAITCNT_ITEM 2
}

	ld_s	spr_flags,r0		;r0 got the flags
	ld_s	spr_addr,r1		;nab the address
	
	asr	#16,srce_xcen,r2
	asr	#16,srce_ycen,r3
	add	r4,r2
	add	r5,r3
	or	#(cachesize<<16),r2
	or	r31,>>#-16,r3

	st_v	v0,dmaCmd_fromSpr	;set flagz
	st_s	r30,dmaCmd_fromSpr+16	;set iadd
	
	;; Save some info for when the tile is loaded
	ld_s	srcBuffLoad,r0
	nop
	add	#SRC_OFFSET_FILL_RIGHT,r0,r1
{	st_s	r28,(r1)
	add	#SRC_OFFSET_FILL_LEFT,r0,r1
}
	st_s	r29,(r1)

	sub	dest_xtile,dest_xsize,r1
	bra	gt,xl_10,nop
	add	r1,dest_xtile
xl_10:
	mv_s	dest_xtile,dma_len

	add	srce_xcen,srcx
	add	srce_ycen,srcy
	sub	r6,>>#-16,srcx
	sub	r7,>>#-16,srcy
	
	add	#SRC_OFFSET_SRCX,r0,r1
	st_s	srcx,(r1)
	add	#SRC_OFFSET_SRCY,r0,r1
	st_s	srcy,(r1)
	
	add	#SRC_OFFSET_DEST_YTILE,r0,r1
	st_s	dest_ytile_r23,(r1)
	
	and	#~($FF<<FLAGS_WAIT_FOR_WRITE),flags_r15
	add	#SRC_OFFSET_DMA_XPOS,r0,r1
	st_v	v3,(r1)
//	st_s	dma_xpos,(r1)
//	add	#SRC_OFFSET_DMA_YPOS,r0,r1
//	st_s	dma_ypos,(r1)
//	add	#SRC_OFFSET_DMA_LEN,r0,r1
//	st_s	dma_len,(r1)
//	add	#SRC_OFFSET_FLAGS,r0,r1
//	st_s	flags_r15,(r1)
	
	bra	doneLoadSrcTile		; borrow from sub below
	ld_v	_mystack4,v7
cachefail:
	sub	r0,r0
	bra	doneLoadSrcTile
	ld_v	_mystack4,v7
	sub	#1,r0

	;; ==================
	lenRemaining_r3	= r3
	xInfo_r4	= r4
	fullMask_r5	= r5
	pixelMask__r6	= r6
	srcBuffer_r7	= r7
	;; ==================
out:
	nop
	mv_s	#$FFFFFFFF,pixelMask__r6
	ls	dma_len,pixelMask__r6		; put zeros in bits we want to write
outTransComp:
	not	pixelMask__r6			; complement the sense of the mask bits
outTrans:
`nextWait:
	ftst	#($FF<<FLAGS_WAIT_FOR_WRITE),flags_r15
	bra	eq,`doneWait,nop
{	jsr	mdma_wr_finished,nop		; wait for previous write to complete
	DMAWAITCNT_ITEM 6
}
{	bra	`nextWait,nop
	sub	#(1<<FLAGS_WAIT_FOR_WRITE),flags_r15
}
`doneWait:

	;; This can be improved
	neg	dma_len
	rot	dma_len,pixelMask__r6		; move bits back so the first pixel is bit 0
	mv_s	#$FFFFFFFF,fullMask_r5		; get the mask assuming all pixels are valid
	ls	dma_len,fullMask_r5
	not	fullMask_r5
	neg	dma_len

	and	fullMask_r5,pixelMask__r6	; mask out undefined bits
	bra	eq,`skipOut,nop			; if mask is all zero, skip the write entirely
	copy	dma_len,lenRemaining_r3		; assume all pixels are valid at first
	
	ld_s	fbDMAFlags,r0			; get dma flags
	ld_s	fbAddress,r1			; get frame buffer pointer
	st_s	r0,dma__cmd
	st_s	r1,dma__cmd+4
	
	ld_s	(dest_info),r1			; get x and y
	nop
	lsr	#16,r1,xInfo_r4			; get X coordinate of sprite
	addm	dma_xpos,xInfo_r4		; offset for this part
	
	addm	dma_ypos,r1			; offset for this part
	and	#$FFFF,r1			; dma_ypos is in lower 16 bits
	or	#1,<>#-16,r1			; strip is 1 pixel high
	st_s	r1,dma__cmd+12
	
	add	#dest_buffer,bufOffset_r8,srcBuffer_r7	; init source buffer

	;; Check if the rest of the pixels are valid.  If so do the final DMA for this bunch.
	;; This makes things faster for those buffers which have no transparent pixels.
`nextPixels:
	and	#$FFFF,xInfo_r4
	cmp	fullMask_r5,pixelMask__r6	; see if all the rest are valid
{	bra	eq,`drawPixels,nop		; if so just draw them
	or	lenRemaining_r3,>>#-16,xInfo_r4	; assume full length
}

	;; Skip over all the 0's in the mask, looking for the first 1.
	ld_s	dma__cmd+8,r0
`skipPixel:
	btst	#0,pixelMask__r6		; is this pixel valid?
{	bra	ne,`foundNextBunch,nop
	st_s	r0,dma__cmd+8
}
	add	#1,xInfo_r4			; advance x pointer
	add	#4,srcBuffer_r7			; advance source buffer
	sub	#1,lenRemaining_r3		; one less pixel to consider
	lsr	#1,pixelMask__r6		; get next pixel
	lsr	#1,fullMask_r5			; shift mask down one as well
	bra	eq,`done,nop			; quit if mask is done
	bra	`skipPixel,nop

	;; Get here when we hit a 1 in the mask.  Now count the number of consecutive 1's
	;; and start the DMA.
`foundNextBunch:
	mv_s	#2,r0				; initialize to bit 1 since we know bit 0 is good
	and	#$FFFF,xInfo_r4
	or	#(1<<16),xInfo_r4		; initialize length
`checkPixel:
	ftst	r0,pixelMask__r6		; is this pixel valid?
	bra	eq,`drawPixels,nop		; if not, we found the end of the bunch, so draw
	lsl	#1,r0				; advance to next bit to check
	add	#(1<<16),xInfo_r4		; increment length
	bra	`checkPixel,nop			; check next pixel, rely on zero at end to jump out

	;; Do the DMA
`drawPixels:
{	jsr	mdma_wait,nop			; wait for previous command to be accepted
	DMAWAITCNT_ITEM 6
}

	st_s	xInfo_r4,dma__cmd+8		; store the x info
	st_s	srcBuffer_r7,dma__cmd+16	; store the source buffer pointer
	st_s	#dma__cmd,mdmacptr		; start DMA
	add	#(1<<FLAGS_WAIT_FOR_WRITE),flags_r15	; increment number of writes to wait for

//{	jsr	mdma_wait,nop
//	DMAWAITCNT_ITEM 11
//}

//	add	#1,curLen_r4			; we know the next pixel is invalid, so skip it here
	lsr	#16,xInfo_r4,r0			; get length
	add	r0,xInfo_r4			; increment x pointer
	add	r0,>>#-2,srcBuffer_r7		; advance source buffer
	sub	r0,lenRemaining_r3		; decrement by number of pixels written
	ls	r0,pixelMask__r6		; shift mask down by bits written
	ls	r0,fullMask_r5			; shift mask down by bits written

	and	fullMask_r5,pixelMask__r6	; check if either are done
	bra	ne,`nextPixels,nop

`done:
	jmp	scanline_done
	nop
	eor	#1,<>#-7,bufOffset_r8		; swap double buffers

	;; Get here when none of the mask bits were set.  Clear the bit that tells the next
	;; loop whether to wait for the previous write to finish.
`skipOut:
	jmp	scanline_done
	and	#~($FF<<FLAGS_WAIT_FOR_WRITE),flags_r15	; don't wait for any writes next time
	eor	#1,<>#-7,bufOffset_r8		; swap double buffers

	;; 
	;; Read the destination pixels for transparency effects
	;;
read_dest:
	push	v0,rz			; this is called by a jsr and itself calls a jsr

{	jsr	mdma_wait,nop
	DMAWAITCNT_ITEM 4
}
	mv_s	#dest_read,r5		; point to dest buffer

	;; Can't do this because the reads continue from
	;; tile to tile as we progress down a column
//	cmp	#1,dest_ytile_r23	; if this is the last scanline in the tile, don't preload
//	bra	eq,skipRead,nop
	
	ld_s	fbDMAFlags,r0		; pick up DMA flags
	ld_s	fbAddress,r1		; fetch dest screen address
	ld_s	(dest_info),r2		; get x and y
	bset	#13,r0			; set READ bit in flags

	addm	dma_ypos,r2,r3		; extract y and offset to sprite location
	and	#$FFFF,r3		; clear top 16 bits of y
	or	#(1<<16),r3		; read one line at a time
	
	lsr	#16,r2			; extract x
	addm	dma_xpos,r2		; offset to sprite location
	and	#$FFFF,r2		; dma_ypos is in lower 16 bits
	or	dma_len,>>#-16,r2	; number of pixels
	
	st_v	v0,dma__cmd		; set first word
	
	mv_s	bufOffset_r8,r6		; copy buffer pointer, gonna flip it

	btst	#FLAGS_NEW_COLUMN,flags_r15	; is this the first time around?
	bra	ne,`notFirst,nop
	addm	r6,r5,r4		; make buffer address
	st_s	r4,dma__cmd+16
	st_s	#dma__cmd,mdmacptr
{	jsr	mdma_wait,nop
	DMAWAITCNT_ITEM 4
}
	
`notFirst:
	add	#1,r3			; point at *next* line
	eor	#1,<>#-7,r6		; flip to opposite buffer
	addm	r6,r5,r4		; make buffer address
	
	st_s	r3,dma__cmd+12		;set first word
	st_s	r4,dma__cmd+16
	st_s	#dma__cmd,mdmacptr
	
{	jsr	mdma_rd_finished,nop	; wait for the read we started the last time to complete
	DMAWAITCNT_ITEM 5
}

	pop	v0,rz
	add	bufOffset_r8,r5		;r5 will point @ current buffer to read srce pixels from.

{	rts	nop
	bset	#FLAGS_NEW_COLUMN,flags_r15
}

fill:
	mv_s	#cachesize,r29
fill_from_left:
; fill r29 columns of pixels to background, from the left side of the srce txture
	st_s	r29,rc1
	add	#(SRC_BUFF_INFO<<2),r1
	mv_s	#((cachesize<<2)*cachesize)-4,r28
foof:
	mv_s	#bg_pixel,r0
	ld_s	(r0),r0
	nop
	mv_s	#(cachesize<<2),r2
filll:
	mv_s	#(cachesize>>2),r3
ffl:
{	st_s	r0,(r1)
	addm	r2,r1,r1
	sub	#1,r3
}
{	st_s	r0,(r1)
	add	r2,r1
	bra	gt,ffl
}
{	st_s	r0,(r1)
	add	r2,r1
}
{	st_s	r0,(r1)
	add	r2,r1
}
	dec	rc1
	jmp	c1ne,filll
	rts
	sub	r28,r1			;truncated nop for rts!
	nop


fill_from_right:
; fill r28 columns of pixels to background, from the right side of the srce txture
	st_s	r28,rc1
	bra	foof
	add	#(SRC_BUFF_INFO<<2)+((cachesize-1)<<2),r1	; Go to end of first line
	mv_s	#((cachesize<<2)*cachesize)+4,r28

;; =================================================================================================
	
	.include	"sincode.s"
	.include	"recip.s"

	;; Matrix preparation - for color conversion including tinting and translucency
	.include	"matprep.s"
	
;; =================================================================================================
	
readPixgen:
	;; ==================
	rendererPtr_r0	= r0
	rendererSize_r1	= r1
	dmaFlags_r1	= r1
	prevPtr_r2	= r2
	;; ==================
	push	v0,rz
	
	push	v0
{	jsr	mdma_wait,nop
	DMAWAITCNT_ITEM 0
}
	
.if (0)
	mv_s	#1,r0
`hang:
	cmp	#1,r0
	jmp	eq,`hang,nop
.endif
	
	pop	v0
	nop
	
	;; r0 holds the address/size of the renderer
	ld_s	prevRenderPtr,prevPtr_r2
	copy	r0,rendererSize_r1
	bits	#8,>>#23,rendererSize_r1	; extract size from [31:23]
	and	#$007FFFFF,rendererPtr_r0	; mask out size bits
	or	#$40000000,rendererPtr_r0	; add proper address bits
	cmp	prevPtr_r2,rendererPtr_r0
	bra	eq,`returnNow,nop

	st_s	rendererPtr_r0,prevRenderPtr
	
	lsl	#16,dmaFlags_r1			; put size in [23:16]
	or	#(1<<13)|(0<<0),dmaFlags_r1	; OR read bit and use type 0 (linear)

	st_s	dmaFlags_r1,dma__cmd
	st_s	rendererPtr_r0,dma__cmd+4
	st_s	#pixgen,dma__cmd+8

	st_s	#dma__cmd,mdmacptr		; start the DMA to read the renderer

`returnNow:
	pop	v0,rz
	nop
	rts	nop
;	bra	readPixgenDone,nop

.if (STANDALONE == 0)
	.align.v
	.include	"sp_pixg0.s"
	.include	"sp_pixg1.s"
	.include	"sp_pixg4.s"
	.include	"sp_pixg6.s"
	
	.include	"spYarTp.s"
	.include	"spYarTpBrightSimple.s"
	.include	"spYarTpBright.s"
	.include	"spYarTpBright_AddRGB.s"
	
	.include	"spYarTlNoSat.s"
	.include	"spYarTlNoSatAlpha.s"
	.include	"spYarTlNoSatAlpha_AddRGB.s"
	.include	"spYarTlNoSatAlpha_RGB.s"
	.include	"spYarTlNoSatAlpha_RGB_AddRGB.s"
	
	.include	"spYarTlSatEnd.s"
	.include	"spYarTlSatEnd_RGB.s"
	.include	"spYarTlSatEndAlpha.s"
	
	.include	"spYarTlSatMidEnd.s"
	.include	"spYarTlSatMidEndAlpha.s"
	
	.include	"spYarTlSatZero.s"
	.include	"spYarTlSatZero_RGB.s"
	.include	"spYarTlSatEndZero.s"
	.include	"spYarTlSatEndZeroAlpha.s"
	
	.include	"sp_yar2X.s"

	.include	"spYarPoint.s"
	.include	"spYarLine.s"
	.include	"spYarGLine.s"
	.include	"spYarBoxTl.s"
	.include	"spYarSimpleTp.s"
.endif

	.segment	spritec
	
//	.align.v
pixgen:
.if (STANDALONE == 1)
	.include	"sp_yar10.s"
.else
	;; Include the longest pixel renderer so we allocate enough room for worst-case
	.ds.b		420
.endif
pixgenEnd:
	.align.s
	.dc.s		$FFFFFFFF		; marker so we know if it's overwritten

