#ifndef _QUEUE_H_
#define _QUEUE_H_

#ifdef LIBSPRITE_INLINE
#define INLINE1 static inline
#define INLINE2 __attribute__((always_inline))
#else
#define INLINE1
#define INLINE2
#endif

enum {
  kQueueFlags_Sticky = (1<<0),
} eQueueFlags;

typedef struct priqueue;

//typedef union {
//  struct priqueue *ptr;
//  int index;
//} qPtr;

typedef struct priqueue {
  //  qPtr prev;
  //  qPtr next;
  struct priqueue *prev;
  struct priqueue *next;
  unsigned short priority;
  unsigned short flags;
} PriorityQueueMember;

/* here's the queue as a whole */
typedef struct pqueue {
    PriorityQueueMember *list;
} PriorityQueue;

void *         QInitMem(void *mem, unsigned num_elems, unsigned size_elems);
void           QInit_func(PriorityQueue *queue, PriorityQueueMember *initialmem);
INLINE1 void   QAdd(PriorityQueue *queue, PriorityQueueMember *member, int comparison);// INLINE2;
int            QRemove(PriorityQueue *queue, PriorityQueueMember *member);
INLINE1 PriorityQueueMember * QGetHead(PriorityQueue *queue);// INLINE2;
void           QPutHead(PriorityQueue *queue, PriorityQueueMember *m);
int            QIsEmpty(PriorityQueue *q);
int            QGetSize(PriorityQueue *queue);

#define QInit(queue, initial)\
    ((PriorityQueue *) queue)->list = initial;

/* priority macros */
#define ComparePriorities(a,b) ((long)((a) - (b)))
#define LowerPriority(a,b) (ComparePriorities(a,b) > 0)
#define LowerOrEqualPriority(a,b) (ComparePriorities(a,b) >= 0)
#define HigherPriority(a,b) (ComparePriorities(a,b) < 0)
#define HigherOrEqualPriority(a,b) (ComparePriorities(a,b) <= 0)

#endif
