;;; ================================================================================================
;;; 
;;; Draws sprites that have no rotation or scaling.
;;;
;;; Transparency: Yes
;;; Brightness:	  No
;;; Translucency: No
;;; 
;;; ================================================================================================

	.overlay spSTp
	.origin pixgen
	
	.include "sp_def.i"

	coord_v1	= v1
	coord0_r4	= r4
	coord1_r5	= r5
	coord2_r6	= r6
	coord3_r7	= r7
//	coord4_r8	= r8
//	coord5_r9	= r9
//	coord6_r10	= r10

	skipXStart_r8	= r8
	numPixels_r9	= r9
	
	srcW_r12	= r12
	srcH_r13	= r13
	buffX_r14	= r14
	buffY_r15	= r15

	curX_r16	= r16
	curY_r17	= r17
	wRemaining_r18	= r18
	curW_r19	= r19

	srcPtr_r20	= r20
	offsetX_r21	= r21

	clipXMin_r24	= r24
	clipXMax_r25	= r25
	clipYMin_r26	= r26
	clipYMax_r27	= r27
	
pixelTypeYarSimpleTp:
	push	v2
	push	v3
	push	v4
//	push	v5
//	push	v6
//	push	v7

	;; Get all the destination coordinates
	ld_v	sprSimpleXY_v,coord_v1
//	ld_s	sprSimpleX0Y0,coord0_r4
//	ld_s	sprSimpleX1Y1,coord1_r5
//	ld_s	sprSimpleX2Y2,coord2_r6
//	ld_s	sprSimpleX3Y3,coord3_r7
//	ld_s	sprSimpleX4Y4,coord4_r8
//	ld_s	sprSimpleX5Y5,coord5_r9
//	ld_s	sprSimpleX6Y6,coord6_r10

	ld_s	sprSimpleSrcFlags,r12
	ld_s	sprSimpleSrcPtr,r13
	ld_s	sprSimpleSrcX,r14
	ld_s	sprSimpleSrcY,r15
//	ld_v	sprSimpleSrcData_v,v3
//	nop
	or	#(1<<13),r12			; set READ bit
	st_s	r12,dma__cmd+0			; flags
	ld_s	sprSimpleSrcWH,r12		; reuse r12 & r13 for width/height
	st_s	r13,dma__cmd+4			; pointer
	and	#$FFFF,r12,srcH_r13
	lsr	#16,srcW_r12

	;; 
	;; Read in all the source pixels.  This renderer assumes we have enough room to fit
	;; them all in local memory.  It reads one line at a time so it also assumes that
	;; each line isn't so long that it will hog MDMA for too long (<64 pixels to be safe).
	;;
	
	mv_s	#source_tile1,srcPtr_r20	; MPE buffer
	copy	buffY_r15,curY_r17
	st_s	srcH_r13,rc0

`readNextRow:
//	copy	buffX_r14,curX_r16
//	copy	srcW_r12,wRemaining_r18
	;; Construct Y/H parameter for DMA command
	copy	curY_r17,r0
	or	#1,<>#16,r0
	st_s	r0,dma__cmd+12

//`continueReadingRow:
//	;; Construct X/W parameter for DMA command
//	mv_s	#64,curW_r19
//	cmp	curW_r19,wRemaining_r18
//	bra	gt,`gotReadWidth,nop
//	copy	wRemaining_r18,curW_r19
//`gotReadWidth:
	;; Construct X/W parameter for DMA command
	copy	buffX_r14,r0
//	copy	curX_r16,r0
//	or	curW_r19,>>#-16,r0
	or	srcW_r12,>>#-16,r0
	st_s	r0,dma__cmd+8

	st_s	srcPtr_r20,dma__cmd+16
	st_s	#dma__cmd,mdmacptr
	jsr	mdma_wait,nop

	;; See if we're done with this row
	add	srcW_r12,>>#-2,srcPtr_r20	; increment the destination buffer pointer
//	add	curW_r19,>>#-2,srcPtr_r20	; increment the destination buffer pointer
//	add	curW_r19,curX_r16		; increment the X coordinate
//	sub	curW_r19,wRemaining_r18		; decrement the remaining width on this row
//	bra	gt,`continueReadingRow,nop	; if width > 0 then we're not done with this row

	;; See if we're done with the whole thing
	add	#1,curY_r17			; increment the Y coordinate
	dec	rc0				; decrement the remaining height of the image
	bra	c0ne,`readNextRow,nop		; if height != 0 then we're not done yet

	jsr	mdma_finished,nop

	;;
	;; Sprite image is done reading at this point.
	;;
	
	;; Set up to write pixels out to the frame buffer
	ld_s	fbDMAFlags,r0
	ld_s	fbAddress,r1
	st_s	r0,dma__cmd+0			; flags
	st_s	r1,dma__cmd+4			; buffer ptr

	;; Load clipping region
	ld_s	xclip,clipXMin_r24		; pick up the X clip params
	ld_s	yclip,clipYMin_r26		; pick up the Y clip params
	lsr	#16,clipXMin_r24,clipXMax_r25	; get max X
	lsr	#16,clipYMin_r26,clipYMax_r27	; get max Y
	and	#$FFFF,clipXMin_r24		; get min X
	and	#$FFFF,clipYMin_r26		; get min Y

`nextSprite:
	;; Get current sprite starting coordinates
	copy	coord0_r4,buffX_r14
	and	#$FFFF,buffX_r14
	lsr	#16,coord0_r4,buffY_r15
	
	;; Coordinates are given from the sprite's center.  Offset that back to the top-left.
	sub	srcW_r12,>>#1,buffX_r14
	sub	srcH_r13,>>#1,buffY_r15

	;; Make sure this sprite lies within the current slice.
	add	buffX_r14,srcW_r12,r0
	cmp	clipXMin_r24,r0
	bra	lt,`skipSprite,nop		; skip if right edge of sprite < left edge of region
;	add	buffY_r15,srcH_r13,r0	;will be done later
;	cmp	clipYMin_r26,r0
;	bra	lt,`skipSprite,nop		; skip if bottom edge of sprite < top edge of region
	cmp	clipXMax_r25,buffX_r14
	bra	gt,`skipSprite,nop		; skip if left edge of sprite > right edge of region
	cmp	clipYMax_r27,buffY_r15
	bra	gt,`skipSprite,nop		; skip if top edge of sprite > bottom edge of region

	;; Now that we know we're somewhere in or above the clipping region, get the starting pixel
	mv_s	#source_tile1,srcPtr_r20	; MPE buffer

	;; Get the number of lines to write, factoring in clipping on the top side of the image.
	;; Clipping on the bottom will be handled by comparing with clipYMax in the main loop.
	sub	buffY_r15,clipYMin_r26,r0
	bra	ge,`gotSkipYStart,nop
	eor	r0,r0
`gotSkipYStart:
	cmp	srcH_r13,r0			; skip if the sprite is not in the region
	bra	ge,`skipSprite
	sub	r0,srcH_r13,r1			; subtract the number of lines to write
	st_s	r1,rc0				; store the number of lines to iterate over
	add	buffY_r15,r0,curY_r17		; offset the starting Y coordinate
	mul	srcW_r12,r0,>>#-2,r0		; offset the buffer pointer
	nop
	add	r0,srcPtr_r20			; ...

	;; Get the number of pixels to skip at the start of each row.
	sub	buffX_r14,clipXMin_r24,skipXStart_r8
	bra	ge,`gotSkipXStart,nop
	eor	skipXStart_r8,skipXStart_r8
`gotSkipXStart:

	;; 
	;; Now start writing out lines of pixels, taking care not to write transparent pixels.
	;; 

`writeNextRow:
	add	skipXStart_r8,buffX_r14,curX_r16
	sub	skipXStart_r8,srcW_r12,r0	; adjust the width
	add	skipXStart_r8,>>#-2,srcPtr_r20	; skip the pixels in the buffer
	st_s	r0,rc1				; store number of pixels to consider this row
	
	;; Construct Y/H parameter for DMA command
	copy	curY_r17,r0
	or	#1,<>#16,r0
	st_s	r0,dma__cmd+12

	mv_s	#0,numPixels_r9
`continueWritingRow:
	bra	c1eq,`rowDone,nop
	ld_s	(srcPtr_r20),r0
	dec	rc1
	cmp	#$10808001,r0
{	bra	eq,`continueWritingRow
	cmp	clipXMax_r25,curX_r16		; if end of line is outside clipping region, skip
}
{	add	#4,srcPtr_r20
	bra	gt,`continueWritingRow
}
	add	#1,curX_r16
	nop
	;; Got here so pixel must be opaque.
	sub	#4,srcPtr_r20,r0
	st_s	r0,dma__cmd+16			; pointer to first non-transparent pixel
	sub	#1,curX_r16,numPixels_r9	; start creating W/H dma parameter
`nonTransparent:
	add	#1,>>#-16,numPixels_r9		; increment pixel count
	bra	c1eq,`writePixels,nop
	cmp	clipXMax_r25,curX_r16		; if end of line is outside clipping region, skip
	bra	gt,`writePixels
{	ld_s	(srcPtr_r20),r0
	add	#4,srcPtr_r20
}
{	dec	rc1
	add	#1,curX_r16
}
	cmp	#$10808001,r0
	bra	ne,`nonTransparent,nop
`writePixels:
	;; Got here so must have hit a transparent pixel.  Write out the pixels we found.
	st_s	numPixels_r9,dma__cmd+8		; already has W & X
	st_s	#dma__cmd,mdmacptr		; write the pixels
	jsr	mdma_wait,nop
	mv_s	#0,numPixels_r9			; clear the pixel count
	bra	c1ne,`continueWritingRow,nop	; keep going if more pixels to write
	
`rowDone:
	;; See if we're done with this row
//	add	curW_r19,>>#-2,srcPtr_r20	; increment the destination buffer pointer
//	add	curW_r19,curX_r16		; increment the X coordinate
//	sub	curW_r19,wRemaining_r18		; decrement the remaining width on this row
//	bra	gt,`continueWritingRow,nop	; if width > 0 then we're not done with this row

	;; See if we're done with the whole thing
	add	#1,curY_r17			; increment the Y coordinate
	dec	rc0				; decrement the remaining height of the image
	bra	c0ne,`writeNextRow,nop		; if height != 0 then we're not done yet

`skipSprite:
{	mv_s	coord1_r5,coord0_r4
	cmp	#$FFFFFFFF,coord1_r5
}
{	bra	ne,`nextSprite
	copy	coord2_r6,coord1_r5
}
	copy	coord3_r7,coord2_r6
	mv_s	#$FFFFFFFF,coord3_r7
//	copy	coord4_r8,coord3_r7
//	copy	coord5_r9,coord4_r8
//	copy	coord6_r10,coord5_r9
	
`done:
	jsr	mdma_wait,nop
	
//	pop	v7
//	pop	v6
//	pop	v5
	pop	v4
	pop	v3
	pop	v2
	
	pop	v0,rz
	nop
	jmp	spriteDoneOuter,nop
	
pixelTypeYarSimpleTp_end:
	