;;; ================================================================================================
;;; 
;;; Yaroze-style renderer
;;;
;;; Transparency: YES
;;; Translucency: NO
;;; Brightness:   YES (additive brightness)
;;;
;;; This is a special renderer that will add a constant RGB value to every pixel.  This is used in
;;; Decaying Orbit when the screen flashes white.
;;;
;;; Num ticks:
;;;   Normal      - ?
;;;   Transparent - ?
;;;
;;; ================================================================================================

	.overlay spTpBP
	.origin pixgen
	
	.include "sp_def.i"
	
pixelTypeYarTpBright_AddRGB:

.if (PERFMON_ENABLE == 1)
;	ld_s	perfmonPixels+32,r0
;	nop
;	add	dma_len,r0
;	st_s	r0,perfmonPixels+32
.endif

	push	v2
	push	v3
//	push	v4		; v4 is saved before getting here
	push	v5
	push	v6
	push	v7
	
	;; Get inputs
	st_s	inpBufPtr_r16,xybase
	
	eor	pixelMask_r6,pixelMask_r6	; clear the mask
	
	copy	tosource[0],ruInc_r0		; save these since we're destroying v7...
	copy	tosource[2],rvInc_r1		; ...
	
`next_pixel:
	ld_s	(uv),srcPixel_r2		; ...and as a scalar
	nop
	cmp	#$10808001,srcPixel_r2		; check for transparency
	bra	eq,`transparent,nop
	
	ld_p	(uv),srcPixel_v2		; get the pixel components
	nop
	copy	inp1dot24_r19,r11

	ld_v	convYToFG,convYToFG_v5		; matrix to convert the pixel to RGB...
	ld_v	convCrToFG,convCrToFG_v6	; ...
	ld_v	convCbToFG,convCbToFG_v7	; ...

	dotp	convYToFG_v5,srcPixel_v2,>>#24,destPixelR_r12
	dotp	convCrToFG_v6,srcPixel_v2,>>#24,destPixelG_r13
	dotp	convCbToFG_v7,srcPixel_v2,>>#24,destPixelB_r14
	copy	r11,r15

	ld_p	spr_add_rgb,v4
	nop
	add_p	v4,v3

	;; Saturate for high end
	sat	#31,destPixelR_r12		; saturate foreground
	sat	#31,destPixelG_r13		; ...
	sat	#31,destPixelB_r14		; ...
	
	;; Convert final pixel back to YCrCb
	ld_v	convToY,convToY_v5		; get matrix to convert from RGB to YCrCb
	ld_v	convToCr,convToCr_v6
	ld_v	convToCb,convToCb_v7
	dotp	destPixelRGB_v3,convToY_v5,>>#24,destPixelY_r16
	dotp	destPixelRGB_v3,convToCr_v6,>>#24,destPixelCr_r17
	dotp	destPixelRGB_v3,convToCb_v7,>>#24,destPixelCb_r18
	nop

	st_p	destPixel_v4,(xy)
	
	bset	#0,pixelMask_r6
	
`transparent:
	addr	#(1<<16),rx			; advance to next dest pixel
	addr	ruInc_r0,ru			; advance to next sprite pixel...
	addr	rvInc_r1,rv			; ...
	rot	#1,pixelMask_r6

	dec	rc0
	bra	c0ne,`next_pixel,nop
	
`done:
	pop	v7
	pop	v6
	pop	v5
//	pop	v4		; v4 is restored after returning
	pop	v3
	bra	outTrans
	pop	v2
	nop
	
endPixelTypeYarTpBright_AddRGB:
