;;; ================================================================================================
;;; 
;;; Standard sprite renderer
;;;
;;; Transparency: YES
;;; Translucency: NO
;;; Tinting:      NO
;;; Bilerp:       NO
;;;
;;; pixg1 - inner lloop for esprite
;;; pixel replicate with transparency
;;;
;;; Num ticks:
;;;   Normal      - 3, 4, or 5
;;;   Transparent - 3, 4, or 5
;;;
;;; ================================================================================================

	
	.overlay pixgen1
	.origin pixgen

	.include "sp_def.i"
	
pixelType1:
	
.if (PERFMON_ENABLE == 1)
	ld_s	perfmonPixels+4,r0
	nop
	add	dma_len,r0
	st_s	r0,perfmonPixels+4
.endif

	;; Get inputs
	copy	inpBufPtr_r16,dstPtr_r4		; grab the parameters that were passed in
	
	mv_s	#1,const1_r5
	mv_s	#$FFFFFF00,mask_r0		; create a mask to AND with every pixel
{	ld_s	(uv),srcPixel1_r1		; load first pixel
	addr	tosource[2],rv			; advance to next source pixel...
}
{	addr	tosource[0],ru			; ...continuing to advance to next source pixel
	ld_s	bg_pixel,transColor_r7		; load color to consider transparent
}
	and	mask_r0,srcPixel1_r1		; mask out unused bits in first pixel
{	and	mask_r0,transColor_r7		; mask out unused bits in transparent color
	st_s	dstPtr_r4,xybase		; set up XY register to point at dest buffer
}
{	st_s	#(4<<20),xyctl			; pixel type 4 (scalar)
	copy	srcPixel1_r1,srcPixel2_r2	; don't know which we'll use so copy to both
}
	eor	pixelMask_r6,pixelMask_r6

	btst	#0,dma_len
	bra	eq,`nextPixel_prevTrans_2,nop	; assume not transparent is more efficient (??)
{	bra	`nextPixel_prevTrans_1,nop
	cmp	transColor_r7,srcPixel2_r2
	ld_s	(uv),srcPixel1_r1
}
	
`nextPixel_prevNoTrans_2:
{	bra	c0eq,outTrans			; jump out if no more pixels
	cmp	transColor_r7,srcPixel1_r1	; is this pixel transparent?
	ld_s	(uv),srcPixel2_r2		; preload next source pixel
	addr	tosource[0],ru			; ...continue advancing to next source pixel
}
{	bra	ne,`nextPixel_prevNoTrans_1	; not transparent, do next pixel
	dec	rc0				; decrement pixel count
	addr	tosource[2],rv			; advance to next source pixel...
	rot	#1,pixelMask_r6
}
{	addr	#(1<<16),rx			; ...continue advancing to next source pixel
	bra	`nextPixel_prevTrans_1		; process next pixel (transparent fall-through)
	st_s	srcPixel1_r1,(xy)		; store the pixel speculatively
	and	mask_r0,srcPixel2_r2		; make preloaded source pixel official
}
{	cmp	transColor_r7,srcPixel2_r2	; pre-compare
	ld_s	(uv),srcPixel1_r1		; preload next source pixel
	addm	const1_r5,pixelMask_r6		; speculatively set pixel mask bit
}
	subm	const1_r5,pixelMask_r6		; oops, pixel was clear, clear the mask bit
	
`nextPixel_prevNoTrans_1:
{	bra	ne,`nextPixel_prevNoTrans_2	; not transparent, do next pixel
	addr	tosource[0],ru			; ...continue advancing to next source pixel
	st_s	srcPixel2_r2,(xy)		; store the pixel speculatively
	rot	#1,pixelMask_r6
}
{	bra	`nextPixel_prevTrans_2		; process next pixel (transparent fall-through)
	dec	rc0				; decrement pixel count
	addr	tosource[2],rv			; advance to next source pixel...
	and	mask_r0,srcPixel1_r1		; make preloaded source pixel official
	addm	const1_r5,pixelMask_r6		; speculatively set pixel mask bit
}
	addr	#(1<<16),rx			; ...continue advancing to next source pixel
	subm	const1_r5,pixelMask_r6		; oops, pixel was clear, clear the mask bit
	
	;; 
	;; Assuming transparent
	;; 
`nextPixel_prevTrans_2:
{	bra	c0eq,outTrans			; jump out if no more pixels
	cmp	transColor_r7,srcPixel1_r1	; is this pixel transparent?
	ld_s	(uv),srcPixel2_r2		; preload next source pixel
	addr	tosource[0],ru			; ...continue advancing to next source pixel
}
{	bra	eq,`nextPixel_prevTrans_1	; not transparent, do next pixel
	dec	rc0				; decrement pixel count
	addr	tosource[2],rv			; advance to next source pixel...
	rot	#1,pixelMask_r6
}
{	addr	#(1<<16),rx			; ...continue advancing to next source pixel
	bra	`nextPixel_prevNoTrans_1	; process next pixel (transparent fall-through)
	st_s	srcPixel1_r1,(xy)		; store the pixel speculatively
	and	mask_r0,srcPixel2_r2		; make preloaded source pixel official
}
{	cmp	transColor_r7,srcPixel2_r2	; pre-compare
	ld_s	(uv),srcPixel1_r1		; preload next source pixel
}
	addm	const1_r5,pixelMask_r6		; pixel was not transparent so set mask bit
	
`nextPixel_prevTrans_1:
{	bra	eq,`nextPixel_prevTrans_2	; not transparent, do next pixel
	addr	tosource[0],ru			; ...continue advancing to next source pixel
	st_s	srcPixel2_r2,(xy)		; store the pixel speculatively
	rot	#1,pixelMask_r6
}
{	bra	`nextPixel_prevNoTrans_2	; process next pixel (transparent fall-through)
	dec	rc0				; decrement pixel count
	addr	tosource[2],rv			; advance to next source pixel...
	and	mask_r0,srcPixel1_r1		; make preloaded source pixel official
}
	addr	#(1<<16),rx			; ...continue advancing to next source pixel
	addm	const1_r5,pixelMask_r6		; pixel was not transparent so set mask bit
	
endPixelType1:
