;;; ================================================================================================
;;; 
;;; Yaroze-style renderer
;;;
;;; Transparency: YES
;;; Translucency: YES
;;; Brightness:   YES
;;;
;;; <description>
;;;
;;; Num ticks:
;;;
;;; ================================================================================================

	.overlay pixyar2X
	.origin pixgen
	
.ifndef PERFMON_ENABLE
	PERFMON_ENABLE	= 0
.endif

	.include "sp_def.i"
	
pixelTypeYar2X:

.if (PERFMON_ENABLE == 1)
	ld_s	perfmonPixels+8,r0
	nop
	add	dma_len,r0
	st_s	r0,perfmonPixels+8
.endif

	jsr	read_dest,nop
		
	push	v2
	push	v3
	push	v4
	push	v5
	push	v6
	push	v7

	st_s	dma_len,rc0			; number of pixels to draw
	eor	pixelMask_r6,pixelMask_r6	; clear the mask
	
	add	#dest_buffer,bufOffset_r8,r0	; get dest buffer address w/double buffer
	st_s	r0,xybase
	st_s	#(4<<20),xyctl			; type 4 pixels = scalar
	st_s	#(0<<16),rx
	
	copy	tosource[0],ruInc_r0		; save these since we're destroying v7...
	copy	tosource[2],rvInc_r1		; ...
	
	ld_s	spr_trans,bgTrans_r7		; get background scale amount
	nop
	and	#$FFFF0000,bgTrans_r7
	asr	#6,bgTrans_r7
	
`next_pixel:
	ld_s	(uv),srcPixel_r2		; ...and as a scalar
	ld_s	(bgPtr_r5),bgPixel_r3		; ...and as a scalar
	cmp	#$10808001,srcPixel_r2		; check for transparency
{	bra	eq,`transparent,nop
	st_s	bgPixel_r3,(xy)
}
	
	ld_p	(uv),srcPixel_v2		; get the pixel components
	nop
	mv_s	#(1<<24),r11

	ld_v	convYToFG,convYToFG_v5		; matrix to convert the pixel to RGB...
	ld_v	convCrToFG,convCrToFG_v6	; ...while applying both tint and...
	ld_v	convCbToFG,convCbToFG_v7	; ...translucency

	dotp	convYToFG_v5,srcPixel_v2,>>#24,fgPixelR_r16
	dotp	convCrToFG_v6,srcPixel_v2,>>#24,fgPixelG_r17
	dotp	convCbToFG_v7,srcPixel_v2,>>#24,fgPixelB_r18

	sat	#31,fgPixelR_r16		; saturate foreground to [-1,1)
	sat	#31,fgPixelG_r17		; ...
	sat	#31,fgPixelB_r18		; ...
	
	ld_p	(bgPtr_r5),bgPixel_v3		; get the pixel components
	copy	r11,r15

	ld_v	convToR,convToR_v5		; matrix to convert background to RGB
	ld_v	convToG,convToG_v6		; ...
	ld_v	convToB,convToB_v7		; ...
	
	dotp	bgPixel_v3,convToR_v5,>>#24,bgPixelR_r8
	dotp	bgPixel_v3,convToG_v6,>>#24,bgPixelG_r9
	dotp	bgPixel_v3,convToB_v7,>>#24,bgPixelB_r10
	nop
	mul_p	bgTrans_r7,bgPixelRGB_v2,>>#24,destPixelRGB_v3 ; apply translucency
	nop
`skipBGTrans:

	add_p	fgPixelRGB_v4,destPixelRGB_v3	; combine foreground and background

	;;=================================================
	;; Perform signed saturation to a range of [0,max]
	eor	tmp1_r16,tmp1_r16		; constant zero
{	sat	#31,destPixelR_r12			; saturate to max
	subm	destPixelR_r12,tmp1_r16,tmp2_r17	; negate color component
}
{	sat	#31,destPixelG_r13
	subm	destPixelG_r13,tmp1_r16,tmp3_r18
}
{	sat	#31,destPixelB_r14
	subm	destPixelB_r14,tmp1_r16,tmp4_r19
}
	sat	#1,tmp2_r17				; tmp has mask, all 0=neg, all 1=pos
	sat	#1,tmp3_r18
	sat	#1,tmp4_r19
	and	tmp2_r17,destPixelR_r12			; apply mask to sat to 0 minimum
	and	tmp3_r18,destPixelG_r13
	and	tmp4_r19,destPixelB_r14
	;; Done saturation
	;;=================================================

	;; Convert final pixel back to YCrCb
	ld_v	convToY,convToY_v5		; get matrix to convert from RGB to YCrCb
	ld_v	convToCr,convToCr_v6
	ld_v	convToCb,convToCb_v7
	dotp	destPixelRGB_v3,convToY_v5,>>#24,destPixelY_r16
	dotp	destPixelRGB_v3,convToCr_v6,>>#24,destPixelCr_r17
	dotp	destPixelRGB_v3,convToCb_v7,>>#24,destPixelCb_r18
	nop

	st_p	destPixel_v4,(xy)
	
	bset	#0,pixelMask_r6
	
`transparent:
	addr	#(1<<16),rx			; advance to next dest pixel
	addr	ruInc_r0,ru			; advance to next sprite pixel...
	addr	rvInc_r1,rv			; ...
	add	#4,bgPtr_r5			; advance to next background pixel
	rot	#1,pixelMask_r6

	dec	rc0
	bra	c0ne,`next_pixel,nop
	
`done:
	pop	v7
	pop	v6
	pop	v5
	pop	v4
{//	bra	outTrans
	bra	out
	pop	v3
}
	pop	v2
	nop
	
endPixelTypeYar2X:
	