	cachesize_log2	= 4
	cachesize	= (1<<cachesize_log2)	;total cache size (square)
	tilesize	= (cachesize-2)		;Coz one extra pixel is loaded around the tile edge.
	dmasize		= 32			;length of a dma strip @ dest

FLAGS_NEW_COLUMN	= 0
FLAGS_WAIT_FOR_WRITE	= 8


	.segment sprited
	.origin 0x20100000

_SpriteBase::		
	.align.v
dest_screen:
fbDMAFlags:
	.dc.s	DMAFLAGS		; dmaflags destination
fbAddress:
 	.dc.s	$402aac00		; dest screen
xclip:	
	.dc.s	$01670000		; clipping xmax/xmin 
yclip:
	.dc.s	$00ef0000		; clipping ymax/ymin
clearRenderer:
	.dc.s	0
clrParam1:
bgColor:
	.dc.s	0
clrParam2:
	.dc.s	0
clrParam3:
	.dc.s	0
	
	
	.align.v
	.dc.s	0			; prev object
qinf:
	.dc.s	0			; next object
	.dc.s	0			; depth
rendererInfo:
	.dc.s	0			; renderer pointer & size
_object::
object:		; this has to be vector aligned!!!
	.dc.s	$00420056		;packed 16bit x:y destination position
sprSimpleSrcWH:
	.dc.s	$00100010	 	;size W:H
sprSimpleSrcX:
	.dc.s	$00000000		;source page offset (16:16, x)
sprSimpleSrcY:
gline_colorStart:
	.dc.s	$00000000		;source page offset (16:16, y)

sprSimpleXY_v:
spr_xscale:
	.dc.s	$00001a00		;X scale (16:16)
spr_yscale:
	.dc.s	$00001a00		;Y scale (16:16)
	.dc.s	$0000a444		;Rotate angle (16:16)
spr_trans:
	.dc.s	$00004000		;Translucency/Mix (2:30)

sprSimpleSrcFlags:
spr_flags:
	.dc.s	$0002e040		;DMA flags sprite source
sprSimpleSrcPtr:
spr_addr:
	.dc.s	$40419200		;sprite source
	.dc.s	$10808001		;transparent pixel value
spr_add_rgb:
	.dc.s	$00000000		; amount of RGB to add to each pixel
spr_hint:
spr_bright:
spr_tint:
	.dc.s	$80808000		;target value for tint

	;; ===========================
	;; Need 3 scalars padding here
padding:
	.ds.s	2
const1dot24:		
	.dc.s	(1<<24)
	;; ===========================

	;; Must keep the three DMA command packets contiguous
	.align.v
dma__cmd:	.ds.s	5
	;; ===========================
	;; Need 3 scalars padding here
CommRecvPoi:	.dc.s	CommRecv
srcBuffLoad:	.dc.s	source_tile1
srcBuffDraw:	.dc.s	source_tile2
	;; ===========================
	.align.v
dma__cmd2:
dmaCmd_fromSpr:	.ds.s	5
	;; ===========================
	;; Need 3 scalars padding here
prevRenderPtr:	.ds.s	1
drawTileReturn:	.ds.s	1
pixjump_loc:	.ds.s	1
	;; ===========================
	.align.v
dma__cmd3:	.ds.s	5
	;; ===========================
	;; Need 3 scalars padding here
prevRenderer:	.dc.s	0
prevSprAddr:	.dc.s	0
		.ds.s	1
	;; ===========================
		
	.align.v
_mystack:	.ds.v	3
_mystack2:	.ds.v	3
_mystack4:	.ds.v	2

RecipLUT:
	.include "_reciplut.i"
	
	;; Performance monitoring stuff
.if (WAITCNT_ENABLE == 1)
	.align.v
dmawaitcnt:	.ds.s	12
	;; Offset by 16 bytes so we can use the smaller form of add-immediate
	DMAWAITCNT_START	= (dmawaitcnt+16)
.macro DMAWAITCNT_ITEM x
	mv_s	#(x<<2)-16,r1
.mend
.else
.macro DMAWAITCNT_ITEM x
.mend	
.endif
	
.if (PERFMON_ENABLE == 1)
perfmonSprites:		.ds.s	1
perfmonTilesTotal:	.ds.s	1
perfmonTilesDrawn:	.ds.s	1
perfmonScanlines:	.ds.s	1
perfmonPixels:		.ds.s	9	; One for each pixel type
.endif

	.include	"sinjmp.s"
	
	.align.v
	.include	"colormat.s"		; should be on vector boundary

	SRC_BUFF_H		= cachesize+1
	SRC_BUFF_W		= cachesize
	SRC_BUFF_INFO		= 12
	SRC_BUFF_SIZE		= ((SRC_BUFF_H * SRC_BUFF_W) + SRC_BUFF_INFO)
	
	SRC_OFFSET_DMA_XPOS	= 0
	SRC_OFFSET_DMA_YPOS	= 4
	SRC_OFFSET_DMA_LEN	= 8
	SRC_OFFSET_FLAGS	= 12
	SRC_OFFSET_FILL_RIGHT	= 16
	SRC_OFFSET_FILL_LEFT	= 20
	SRC_OFFSET_SRCX		= 24
	SRC_OFFSET_SRCY		= 28
	SRC_OFFSET_DEST_YTILE	= 32
	.align.v
source_tile1:	.ds.s 	SRC_BUFF_SIZE
	.align.v
source_tile2:	.ds.s 	SRC_BUFF_SIZE

;extra_space:	.ds.s	512
	
	.align.v
;;; Destination buffer to write pixels into prior to DMA
tmpdata:
dest_buffer:
	.ds.s	(32*2)		; double buffer

dest_read:
	.ds.s 	dmasize*2

	.align.v
pixgenParam:	.ds.s	4

	.align.v
TempData:
	.ds.v	1
	
sprTransFGPix:	.ds.s	1		; FG transparency value suitable for pixel format
	
_mpeinfo::
mpeinfo:	.dc.s	$10020300	; 16 pixel slice -- MPE #2 -- 3 rendering MPEs -- no clear
sprBright:
sprTransFG:	.dc.s	$ff000000
sprTransBG:	.dc.s	$01000000

expectedData:
	.dc.s	$00000000,$01010101,$02020202,$03030303
	.dc.s	$04040404,$05050505,$06060606,$07070707
	.dc.s	$08080808,$09090909,$0A0A0A0A,$0B0B0B0B
	.dc.s	$0C0C0C0C,$0D0D0D0D,$0E0E0E0E,$0F0F0F0F
	.dc.s	$10101010,$11111111,$12121212,$13131313
	.dc.s	$14141414,$15151515,$16161616,$17171717
	.dc.s	$18181818,$19191919,$1A1A1A1A,$1B1B1B1B
	.dc.s	$1C1C1C1C,$1D1D1D1D,$1E1E1E1E,$1F1F1F1F
	.dc.s	$20202020,$21212121,$22222222,$23232323
	.dc.s	$24242424,$25252525,$26262626,$27272727
	.dc.s	$28282828,$29292929,$2A2A2A2A,$2B2B2B2B
	.dc.s	$2C2C2C2C,$2D2D2D2D,$2E2E2E2E,$2F2F2F2F
